function commentLike(autoId) {
	if ( !inc.isLogin(true) ) return;
	var o = pub.comms['autoId_' + autoId]; if (!o) return;
		o.likes = inc.anyToInt( o.likes );
	
	var eEle = inc.strToEle('#autoId_' + o.autoId + ' .like em');
	var iEle = inc.strToEle('#autoId_' + o.autoId + ' .like i');
		inc.htmlSet(eEle,'...');
		inc.classListAdd(iEle,'isLike');
		
	var fun = {};
		fun.xhrRet = function(xhrRet) {
			//inc.isDevelop && console.log( 'xhrRet-' + xhrRet.retData );
			var retObj = inc.ajax.xhrToEval(xhrRet.retData);
			if (o.saleId == 0 && o.artiId == 0) return;
			if (o.saleId >= 1 && !inc.equal(o.saleId,retObj.lists.saleId)) return;
			if (o.artiId >= 1 && !inc.equal(o.artiId,retObj.lists.artiId)) return;
			if (retObj.retStr == 'ok') {
				var r = {};
					r.saleId  = inc.anyToInt( retObj.lists.saleId );
					r.artiId  = inc.anyToInt( retObj.lists.artiId );
					r.commId  = inc.anyToInt( retObj.lists.commId );
					r.likes   = inc.anyToInt( retObj.lists.likes );
					r.isBack  = inc.anyToInt( retObj.lists.isBack );
					r.meScore = inc.anyToInt( retObj.lists.meScore );
					o.likes   = r.likes;
				if (r.isBack == 1) {
					inc.indexHomeSignToReload();//标记更新用户信息
					r.meScore >= 1 ? inc.showToast('点赞成功 金币+' + r.meScore) : inc.showToast('点赞成功');
				} else if (r.isBack == 2) {
					inc.showToast('已赞过了');
				}
				inc.htmlSet(eEle,r.likes);
			}else{
				inc.htmlSet(eEle,o.likes);
			    //返回错误信息
			    var retErr = inc.ajax.errorFirst(retObj.retStr);
			    if ( retErr === false ) {
			    	inc.ajax.errorFinal(retObj.retStr);
			    }
			}
		};
	inc.ajax.send({
		xUrl : pub.urls.commentLike,
		data : {
			saleId : o.saleId,
			artiId : o.artiId,
			commId : o.commId,
		}
	},fun.xhrRet,function(e){
		inc.showAlert( inc.printObj(e) );
	});
}
function commentDel(autoId) {
	if ( !inc.isLogin(true) ) return;
	var o = pub.comms['autoId_' + autoId]; if (!o) return;
	var p = {};
		p.autoId = autoId;
	if (o.isComm) {
		p.saleId = o.saleId;
		p.artiId = o.artiId;
		p.commId = o.commId;
		p.talkId = 0;
	} else if (o.isSend) {
		p.saleId = pub.comms['autoId_' + o.autoIdCo].saleId;
		p.artiId = pub.comms['autoId_' + o.autoIdCo].artiId;
		p.commId = o.commId;
		p.talkId = 0;
	} else {
		inc.showAlert('error_isComm_isSend_all_false');
		return;
	}
	//inc.isDevelop && console.log('p-' + inc.printObj(p));
	
	var fun = {};
		fun.xhrRet = function(xhrRet) {
			//inc.isDevelop && console.log( 'xhrRet-' + xhrRet.retData );
			var retObj = inc.ajax.xhrToEval(xhrRet.retData);
			if (retObj.retStr == 'ok') {
				var r = {};
					r.saleId   = inc.anyToInt( retObj.lists.saleId );
					r.artiId   = inc.anyToInt( retObj.lists.artiId );
					r.comments = inc.anyToInt( retObj.lists.comments );
				
				//修改评论数
				inc.pullListCommentsAlter({saleId:r.saleId, artiId:r.artiId, comments:r.comments},[pub.o.winIdOpener]);
				
				inc.htmlHide('#autoId_' + p.autoId,true);
				inc.showToast('删除成功');
				setTimeout(function(){
				inc.htmlSet('#title','评论');
				},500);
			}else{
				inc.htmlSet('#title','评论');
			    //返回错误信息
			    var retErr = inc.ajax.errorFirst(retObj.retStr);
			    if ( retErr === false ) {
			    	inc.ajax.errorFinal(retObj.retStr);
			    }
			}
		};
	inc.htmlSet('#title','删除中...');
	inc.ajax.send({
		xUrl : pub.urls.commentDel,
		data : {
			saleId : p.saleId,
			artiId : p.artiId,
			commId : p.commId,
			talkId : p.talkId,
		}
	},fun.xhrRet,function(e){
		inc.showAlert( inc.printObj(e) );
	});
}
function commentList() {
	if (pub.o.comments >= 1) {
		if (pub.isListIng !== true) {
			pub.isListIng = true;
		} else {
			return;
		}
		inc.htmlShow('#listLoad');
		inc.htmlHide('#listNone');
		inc.htmlHide('#listMore');
		inc.htmlHide('#listFini');
	} else {
		inc.htmlHide('#listLoad');
		inc.htmlShow('#listNone');
		inc.htmlHide('#listMore');
		inc.htmlHide('#listFini');
		return;
	}
	var fun = {};
		fun.xhrRet = function(xhrRet) {
			//inc.isDevelop && console.log( 'xhrRet-' + xhrRet.retData );
			var retObj = inc.ajax.xhrToEval(xhrRet.retData);
			if (retObj.retStr == 'ok') {
				setTimeout(function(){
					var defriendObj = inc.storageDefriendObjGet();//拉黑用户
					//inc.isDevelop && console.log( 'defriendObj-' + inc.printObj(defriendObj) );
					
					pub.pages.saleId = inc.anyToInt( retObj.saleId );
					pub.pages.artiId = inc.anyToInt( retObj.artiId );
					pub.pages.page   = inc.anyToInt( retObj.page );
					pub.pages.size   = inc.anyToInt( retObj.size );
					pub.pages.count  = inc.anyToInt( retObj.count );
					pub.pages.alls   = pub.pages.alls + pub.pages.count;
					
					var r = retObj.lists, rHtml = '', t;
					for (var i=0;i<r.length;i++) {
						t = {};
						t.isComm   = true;
						t.commId   = inc.anyToInt( r[i].commId );
						t.saleId   = inc.anyToInt( r[i].saleId );
						t.artiId   = inc.anyToInt( r[i].artiId );
						t.aidme    = inc.anyToInt( r[i].aidme );
						t.nickName = inc.anyToStr( r[i].nickName );
						t.avatImid = inc.anyToStr( r[i].avatImid );
						t.commText = inc.anyToStr( r[i].commText );
						t.pasts    = inc.anyToInt( r[i].pasts );
						t.pastJson = inc.anyToStr( r[i].pastJson );
						t.likes    = inc.anyToInt( r[i].likes );
						t.showtime = inc.anyToInt( r[i].showtime );
			
						//不显示拉黑用户内容
						if (defriendObj['aidto_' + t.aidme])  continue;
						
						//如果该条内容已存在
						if ( inc.strToEle('#commId_' + t.commId) ) continue;
						
						pub.autoId++;
						t.autoId   = pub.autoId;
						t.autoIdCo = t.autoId;
						pub.comms  = pub.comms || {};
						pub.comms['autoId_' + t.autoId] = t;
						
						rHtml += inc.sameCommListHtml(t);
					}
					inc.htmlAppend('#commList',rHtml);
					inc.fileImgLoadImageSet('#commList');
					
					if (pub.pages.alls === 0 || pub.pages.count === 0 || pub.pages.count < pub.pages.size ) {
						if (pub.pages.alls === 0) {
							inc.htmlHide('#listLoad');
							inc.htmlShow('#listNone');
							inc.htmlHide('#listMore');
							inc.htmlHide('#listFini');
						} else {
							inc.htmlHide('#listLoad');
							inc.htmlHide('#listNone');
							inc.htmlHide('#listMore');
							inc.htmlShow('#listFini');
						}
						pub.isPullUpDisable = true;
					} else {
						inc.htmlHide('#listLoad');
						inc.htmlHide('#listNone');
						inc.htmlShow('#listMore');
						inc.htmlHide('#listFini');
					}
					pub.isListIng = false;
				},inc.longToTime(pub.o.loadtime));
			}else{
					pub.isListIng = false;
			    //返回错误信息
			    var retErr = inc.errorAjaxFirst(retObj.retStr);
			    if ( retErr === false ) {
					inc.ajax.errorFinal(retObj.retStr);
			    }
			}
		};
	inc.ajax.send({
		xUrl : pub.urls.commentList,
		data : {
			saleId : pub.o.saleId,
			artiId : pub.o.artiId,
			page   : pub.pages.page + 1
		}
	},fun.xhrRet,function(e){
		inc.showAlert( inc.printObj(e) );
	});
}
function commentAdd() {
	var p = {},  o = {};
		p.autoIdTo = inc.anyToInt( pub.autoIdTo );
		p.saleId   = inc.anyToInt( pub.o.saleId );
		p.artiId   = inc.anyToInt( pub.o.artiId );
		p.commIdTo = 0; //回复某条评论的id
		p.commText = inc.anyToStr( pub.ui.text.value ); //当前所写的评论内容
	if (p.autoIdTo) {
		o = pub.comms['autoId_' + p.autoIdTo]; if (!o) return;
		p.commIdTo = o.commId;
	}
	//inc.isDevelop && console.log('p-' + inc.printObj(p));

	if (pub.isSubIng !== true) {
		pub.isSubIng = true;
		setTimeout(function() {
			pub.isSubIng = false;
		},2000);
	} else {
		return;
	}
	if (inc.isEmptyVal(p.commText)) {
		inc.showToast('请输入评论');
		return;
	}
	
	pub.autoIdTo = 0; //初始化
	pub.ui.text.value = '';//清空内容
	inc.preAutoHeightTxt({tEle:'#commText', cEle:'footer ul.comment', pClass:'A'});//回归正常高度
	pub.mask.talk    && pub.mask.talk.close();
	pub.mask.comment && pub.mask.comment.close();
	pub.ui.textBlur();//关闭输入法
	
	var fun = {};
		fun.xhrRet = function(xhrRet) {
			//inc.isDevelop && console.log( 'xhrRet-' + xhrRet.retData );
			var retObj = inc.ajax.xhrToEval(xhrRet.retData);
			if (p.saleId == 0 && p.artiId == 0) return;
			if (p.saleId >= 1 && !inc.equal(p.saleId,retObj.lists.saleId)) return;
			if (p.artiId >= 1 && !inc.equal(p.artiId,retObj.lists.artiId)) return;
			if (retObj.retStr == 'ok') {
				var r = {};
					r.saleId   = inc.anyToInt( retObj.lists.saleId );
					r.artiId   = inc.anyToInt( retObj.lists.artiId );
					r.commId   = inc.anyToInt( retObj.lists.commId );
					r.talkId   = inc.anyToInt( retObj.lists.talkId );
					r.comments = inc.anyToInt( retObj.lists.comments );
					r.meScore  = inc.anyToInt( retObj.lists.meScore );

				//修改评论数
				inc.pullListCommentsAlter({saleId:r.saleId, artiId:r.artiId, comments:r.comments},[pub.o.winIdOpener]);
				
				var SuObj = inc.storageItemGet('SuObj','object');
				if (p.commIdTo >= 1) {
					var y = {};
						y.isSend   = true;
						y.aidme    = inc.anyToInt( SuObj.aidme );
						y.nickName = inc.anyToStr( SuObj.nickName );
						y.commId   = r.commId;
						y.commText = p.commText;
						y.maketime = inc.localtime();
						
						pub.autoId++;
						y.autoId   = pub.autoId;
						y.autoIdCo = p.autoIdTo; //评论 autoId
						pub.comms  = pub.comms || {};
						pub.comms['autoId_' + y.autoId] = y;
					
					var pHtml = inc.sameTalkListHtml(y);
					var aEle  = inc.strToEle( '#autoId_' + y.autoIdCo );
					var bEle  = inc.strToEle( '#autoId_' + y.autoIdCo + ' ul.bList.sendList' );
					var cEle  = inc.strToEle( '#autoId_' + y.autoIdCo + ' div.send' );
					if (bEle) {
						inc.htmlAppend(bEle,pHtml);
					} else {
						pHtml = '<ul class="bList sendList">' + pHtml + '</ul>';
						if (cEle) {
							inc.htmlPrepend(aEle,pHtml,cEle);
						} else {
							inc.htmlAppend(aEle,pHtml);
						}
					}
					if (r.meScore >= 1) {
						inc.indexHomeSignToReload();//标记更新用户信息
						inc.showToast('回复成功 金币+' + r.meScore);
					} else {
						inc.showToast('回复成功');
					}
				} else {
					inc.scrollToTop(true);
					var t = {};
						t.isComm   = true;
						t.commId   = inc.anyToInt( r.commId );
						t.saleId   = inc.anyToInt( p.saleId );
						t.artiId   = inc.anyToInt( p.artiId );
						t.aidme    = inc.anyToInt( SuObj.aidme );
						t.nickName = inc.anyToStr( SuObj.nickName );
						t.avatImid = inc.anyToStr( SuObj.avatImid );
						t.commText = inc.anyToStr( p.commText );
						t.pasts    = 0;
						t.pastJson = '';
						t.likes    = 0;
						t.showtime = inc.localtime();
					
						pub.autoId++;
						t.autoId   = pub.autoId;
						t.autoIdCo = t.autoId;
						pub.comms  = pub.comms || {};
						pub.comms['autoId_' + t.autoId] = t;
					
					var rHtml = inc.sameCommListHtml(t);
					inc.htmlPrepend('#commList',rHtml);
					inc.fileImgLoadImageSet('#commList',500);

					if (r.meScore >= 1) {
						inc.indexHomeSignToReload();//标记更新用户信息
						inc.showToast('评论成功 金币+' + r.meScore);
					} else {
						inc.showToast('评论成功');
					}
					
					/**
					 * 在ios为解决输入法bug，将#content设为了fixed，所以此处需判断ios
					 * */
					if (inc.isIOS()) {
						inc.scrollToTop('#content');
					} else {
						inc.scrollToTop();
					}
				}
				
				inc.htmlHide('#listLoad');
				inc.htmlHide('#listNone');
				inc.htmlHide('#listMore');
				
				setTimeout(function(){
				inc.htmlSet('#title','评论');
				},500);
			} else {
			    inc.htmlSet('#title','评论');
			    //返回错误信息
			    var retErr = inc.ajax.errorFirst(retObj.retStr);
			    if ( retErr === false ) {
			    	if ( retObj.retStr == 'error_commText_empty' ) {
						inc.showAlert( '请输入评论' );
					} else if ( retObj.retStr == 'error_saleId_check' || retObj.retStr == 'error_artiId_check' ) {
			    		inc.showAlert( '该内容正在编辑或审核中' );
			    	} else if ( retObj.retStr == 'error_saleId_isDelete' || retObj.retStr == 'error_artiId_isDelete' ) {
			    		inc.showAlert( '该内容不存在，可能已被删除');
			    	} else if ( retObj.retStr == 'error_commId_isDelete' ) {
						inc.showAlert( '该评论不存在，可能已被删除' );
					} else {
						inc.ajax.errorFinal(retObj.retStr);
					}
			    }
			}
		};
	inc.htmlSet('#title','发送中...');
	inc.ajax.send({
		xUrl : pub.urls.commentAdd,
		data : {
			saleId   : p.saleId,
			artiId   : p.artiId,
			commIdTo : p.commIdTo,
			commText : p.commText
		}
	},fun.xhrRet,function(e){
		inc.showAlert( inc.printObj(e) );
	});
}
//初始化ui
function uiInit() {
	pub.ui = {
		text   : document.querySelector('footer ul.comment li.text .area textarea'),
		submit : document.querySelector('footer ul.comment li.submit')
	};
	pub.ui.textFocus = function(){
		pub.ui.text.focus();
		setTimeout(function() {
			pub.ui.text.focus();
		}, 150);
	};
	pub.ui.textBlur = function(){
		//让输入框失去焦点从而关闭输入法
		pub.ui.text.blur();
		setTimeout( function() {
			pub.ui.text.blur();
		}, 150 );
		inc.softKeyboardClose();//关闭输入法
	};
	//解决长按“发送”按钮，导致键盘关闭的问题；
	pub.ui.submit.addEventListener('touchstart', function(event) {
		pub.ui.textFocus();
		event.preventDefault();
	},false);
	//解决长按“发送”按钮，导致键盘关闭的问题；
	pub.ui.submit.addEventListener('touchmove', function(event) {
		pub.ui.textFocus();
		event.preventDefault();
	},false);
	//获得焦点
	pub.ui.text.addEventListener('release', function(event) {
		if (pub.mask.talk) {
			return;
		}
		if (pub.mask.comment) {
			return;
		}
		pub.ui.textFocus();
	},false);
	//点击发送
	pub.ui.submit.addEventListener('release', function(event) {
		if (inc.isLogin()) {
			var value = pub.ui.text.value;
			//如果已输入内容则关闭键盘
			if (value) {
				//外部处理函数
				commentAdd();
			} else {
				//解决长按“发送”按钮，导致键盘关闭的问题
				pub.ui.textFocus();
			}
		} else {
			pub.ui.textBlur();
			inc.winOpen('id-login-third.html');
		}
	},false);
	//获得焦点后显示键盘
	pub.ui.text.addEventListener('tap', function(event) {
		/**d-与b中的代码一致*/
		if (pub.autoIdTo) {
			var autoId = pub.autoIdTo;
			if (!pub.mask.talk) {
				/**c-与a中的代码一致*/
				var o = pub.comms['autoId_' + autoId]; if (!o) return;
				inc.htmlSet( 'footer ul.talk li.talkName',o.nickName + ' : ' + (o.commText || o.talkText) );
				inc.htmlShow('footer ul.talk');
				pub.mask.talk = inc.createMask('B',function(){
					pub.mask.talk = null;
					inc.htmlHide('footer ul.talk');
					inc.attrSet('#commText','placeholder','评论');
					pub.ui.textBlur();
				});
				pub.mask.talk.show();//显示遮罩
				inc.attrSet('#commText','placeholder','回复 : ' + o.nickName);
				pub.ui.textFocus();
				/**c-与a中的代码一致*/
			}
		} else {
			if (!pub.mask.comment) {
				pub.mask.comment = inc.createMask('B',function(){
					pub.mask.comment = null;
					pub.ui.textBlur();
				});
				pub.mask.comment.show();//显示遮罩
				pub.ui.textFocus();
			}
		}
		/**d-与b中的代码一致*/
		pub.ui.text.focus();
		setTimeout(function() {
			pub.ui.text.focus();
		}, 0);
	},false);
}