/***超全局变量************************************************************************************/
var inc = {};
	inc.isDevelop = true; //true=开发模式-打印日志和错误
	inc.xhrs      = [];
	inc.mask      = {}; //遮罩层
	inc.autoId    = 1;
	inc.images    = {}; //预加载图片
	inc.priority  = 100; //任务优先级
	inc.preUrlA   = 'https://www.765cn.com/buyeaPhp/'; //服务器地址，方便升级测试
	inc.preUrlU   = 'https://www.765cn.com/buyerPhp/'; //服务器地址，方便升级测试
	inc.urls      = {
		dataSame  : inc.preUrlU + 'same_data_same.php',
		defriend  : inc.preUrlU + 'defriend.php',
	};
/***超全局变量************************************************************************************/
/***标记更新用户信息*********************************************************************************/
inc.indexHomeSignToReload = function() {
	var SuObj = inc.storageItemGet('SuObj','object');
		SuObj.isReload = 1;
	inc.storageItemSet('SuObj',SuObj);
};
/***标记更新用户信息*********************************************************************************/
/***打开爆料链接*********************************************************************************/
/***打开爆料链接*********************************************************************************/
inc.sameIsRight = function(o) {
	o.saleId   = inc.anyToInt( o.saleId );
	o.artiId   = inc.anyToInt( o.artiId );
	o.sameShow = inc.anyToInt( o.sameShow );
	var ret = false;

	//0=编辑审核中,1=所有人可见,2=仅作者可见,3=商品无淘客,4=商品已下架,5=商品不存在,6=被作者删除,7=被管理删除
	if (o.sameShow <= 5) {
		ret = true;
	} else {
		if (o.sameShow == 6 || o.sameShow == 7) {
			if (o.saleId >= 1) {
				inc.showToast('该商品已被删除');
			} else {
				inc.showToast('该文章已被删除');
			}
		} else {
			inc.showToast('该内容所属类别错误');
		}
	}
	return ret;
};
inc.sameDataSameToCall = function(a,callbackS) {
	a.isLoad = typeof a.isLoad === 'boolean' ? a.isLoad : true;
    a.isLoad && inc.showLoadMid(true,'加载中...');
	inc.ajax.send({
		xUrl : inc.urls.dataSame,
		data : {saleId:a.saleId,artiId:a.artiId}
	},function(xhrRet) {
		//inc.isDevelop && console.log( 'xhrRet-' + inc.printObj(xhrRet.retData) );
		var retObj = inc.ajax.xhrToEval(xhrRet.retData);
		if (retObj.retStr === 'ok') {
			a.isLoad && inc.showLoadMid(false);
			var o = retObj.lists;
				o.sameId    = inc.anyToInt( o.sameId );
				o.saleId    = inc.anyToInt( o.saleId );
				o.artiId    = inc.anyToInt( o.artiId );
				o.aidme     = inc.anyToInt( o.aidme );
				o.sameTitle = inc.anyToStr( o.sameTitle );
				o.sameWord  = inc.anyToStr( o.sameWord );
				o.sameImid  = inc.anyToStr( o.sameImid );
				o.sameTips  = inc.anyToStr( o.sameTips );
				o.saleMall  = inc.anyToStr( o.saleMall );
				o.saleTips  = inc.anyToStr( o.saleTips );
				o.isnices   = inc.anyToInt( o.isnices );
				o.unnices   = inc.anyToInt( o.unnices );
				o.likes     = inc.anyToInt( o.likes );
				o.collects  = inc.anyToInt( o.collects );
				o.comments  = inc.anyToInt( o.comments );
				o.testeds   = inc.anyToInt( o.testeds );
				o.artiLevel = inc.anyToInt( o.artiLevel );
				o.isArticle = inc.anyToInt( o.isArticle );
				o.isApstop  = inc.anyToInt( o.isApstop );
				o.isActive  = inc.anyToInt( o.isActive );
				o.isSticky  = inc.anyToInt( o.isSticky );
				o.sameShow  = inc.anyToInt( o.sameShow );
				o.sametime  = inc.anyToInt( o.sametime );
				o.maketime  = inc.anyToInt( o.maketime );
				o.showtime  = inc.anyToInt( o.showtime );
				o.nickName  = inc.anyToStr( o.nickName );
				o.avatImid  = inc.anyToStr( o.avatImid );
			if (inc.sameIsRight(o)) {
				callbackS && callbackS.call(a,o);
			}
		} else {
			a.isLoad && inc.showLoadMid(false);
		    //返回错误信息
		    var retErr = inc.ajax.errorFirst(retObj.retStr);
		    if ( retErr === false ) {
				inc.ajax.errorFinal(retObj.retStr);
		    }
		}
	},function(e){
		inc.showAlert( inc.printObj(e) );
	});
};
inc.sameDataSameToOpen = function(a) {
	a.isLoad = typeof a.isLoad === 'boolean' ? a.isLoad : true;
	a.isLoad && inc.showLoadMid(true,'加载中...');
	inc.ajax.send({
		xUrl : inc.urls.dataSame,
		data : {saleId:a.saleId,artiId:a.artiId}
	},function(xhrRet) {
		//inc.isDevelop && console.log( 'xhrRet-' + inc.printObj(xhrRet.retData) );
		var retObj = inc.ajax.xhrToEval(xhrRet.retData);
		if (retObj.retStr === 'ok') {
			var o = retObj.lists;
				o.sameId    = inc.anyToInt( o.sameId );
				o.saleId    = inc.anyToInt( o.saleId );
				o.artiId    = inc.anyToInt( o.artiId );
				o.aidme     = inc.anyToInt( o.aidme );
				o.sameTitle = inc.anyToStr( o.sameTitle );
				o.sameWord  = inc.anyToStr( o.sameWord );
				o.sameImid  = inc.anyToStr( o.sameImid );
				o.sameTips  = inc.anyToStr( o.sameTips );
				o.saleMall  = inc.anyToStr( o.saleMall );
				o.saleTips  = inc.anyToStr( o.saleTips );
				o.isnices   = inc.anyToInt( o.isnices );
				o.unnices   = inc.anyToInt( o.unnices );
				o.likes     = inc.anyToInt( o.likes );
				o.collects  = inc.anyToInt( o.collects );
				o.comments  = inc.anyToInt( o.comments );
				o.testeds   = inc.anyToInt( o.testeds );
				o.artiLevel = inc.anyToInt( o.artiLevel );
				o.isArticle = inc.anyToInt( o.isArticle );
				o.isApstop  = inc.anyToInt( o.isApstop );
				o.isActive  = inc.anyToInt( o.isActive );
				o.isSticky  = inc.anyToInt( o.isSticky );
				o.sameShow  = inc.anyToInt( o.sameShow );
				o.sametime  = inc.anyToInt( o.sametime );
				o.maketime  = inc.anyToInt( o.maketime );
				o.showtime  = inc.anyToInt( o.showtime );
				o.nickName  = inc.anyToStr( o.nickName );
				o.avatImid  = inc.anyToStr( o.avatImid );
			if (inc.sameIsRight(o)) {
				o.winIdFire = a.winIdFire;
				inc.winFire('same.html','showSameHtml',{o:o});	
			}
			a.isLoad && inc.showLoadMid(false);
		} else {
			a.isLoad && inc.showLoadMid(false);
		    //返回错误信息
		    var retErr = inc.ajax.errorFirst(retObj.retStr);
		    if ( retErr === false ) {
				inc.ajax.errorFinal(retObj.retStr);
		    }
		}
	},function(e){
		inc.showAlert( inc.printObj(e) );
	});
};
inc.sameDataSameToLoad= function(a) {
	a.saleId = inc.anyToInt( a.saleId );
	a.artiId = inc.anyToInt( a.artiId );
	var time = inc.localtime(true);
	var winIdA = 'same.' + time + '.html';
	var winIdB = 'same.child.share.' + time + '.html';
	var winIdC = 'same.child.zoom.'  + time + '.html';
	inc.winOpen({
		winId  : winIdA,
		winUi  : 'same.html',
	},{
		saleId : a.saleId,
		artiId : a.artiId,
		winIdA : winIdA,
		winIdB : winIdB,
		winIdC : winIdC,
	});
};
/***打开爆料链接*********************************************************************************/
/***评论和单聊列表*********************************************************************************/
inc.sameCommListHtml = function (t) {
	t.saleId = inc.anyToInt( t.saleId );
	t.artiId = inc.anyToInt( t.artiId );
	
	var rHtml = '', pHtml = '', sHtml = '', aHtml = '', fHtml = '', y;
	t.avatImui = t.avatImid ? inc.fileAnyToImui(t.avatImid)+inc.fileImgSuffix('avatarSmall').suffix : 'img/avatar.jpg';
	
	t.pastArr = inc.strToEval(t.pastJson,true);
	if (t.pastArr.length >= 1) {
		pHtml += '<ul class="bList pastList">';
		for (var j=0;j<t.pastArr.length;j++) {
			y = {};
			y.isPast   = true;
			y.aidme    = inc.anyToInt( t.pastArr[j].aidme );
			y.nickName = inc.anyToStr( t.pastArr[j].nickName );
			y.commId   = inc.anyToInt( t.pastArr[j].commId );
			y.commText = inc.anyToStr( t.pastArr[j].commText );
			y.maketime = inc.anyToInt( t.pastArr[j].maketime );
			
			pub.autoId++;
			y.autoId   = pub.autoId;
			y.autoIdCo = t.autoId; //评论 autoId
			pub.comms  = pub.comms || {};
			pub.comms['autoId_' + y.autoId] = y;
	
			pHtml += inc.sameTalkListHtml(y);
		}
		pHtml += '</ul>';
	}
	
	t.sendArr = inc.strToEval(t.sendJson,true);
	if (t.sendArr.length >= 1) {
		sHtml += '<ul class="bList sendList">';
		for (var j=0;j<t.sendArr.length;j++) {
			y = {};
			y.isSend   = true;
			y.aidme    = inc.anyToInt( t.sendArr[j].aidme );
			y.nickName = inc.anyToStr( t.sendArr[j].nickName );
			y.commId   = inc.anyToInt( t.sendArr[j].commId );
			y.commText = inc.anyToStr( t.sendArr[j].commText );
			y.maketime = inc.anyToInt( t.sendArr[j].maketime );
			
			pub.autoId++;
			y.autoId   = pub.autoId;
			y.autoIdCo = t.autoId; //评论 autoId
			pub.comms  = pub.comms || {};
			pub.comms['autoId_' + y.autoId] = y;
	
			sHtml += inc.sameTalkListHtml(y);
		}
		sHtml += '</ul>';
	}
	
	if (t.isTalk) {
		fHtml = ''+
			'<a class="title mui-ellipsis" autoId="' + t.autoId + '" doType="same">' + t.sameTitle + '</a>';
		aHtml = ''+
			'<div class="send">'+
				'<div class="area">'+
				'<textarea class="inc-preAutoHeightTxtH" autoId="' + t.autoId + '"'+
					' placeholder="回复 ' + t.nickName + '"></textarea>'+
				'</div>'+
				'<a class="submit" doType="submit" autoId="' + t.autoId + '">发&nbsp;送</a>'+
			'</div>';
	} else {
		fHtml = ''+
			'<a class="like" autoId="' + t.autoId + '" doType="like">'+
				'<em>' + (t.likes || '') + '</em>'+
				'<i class="inc-icon">&#xe600;</i>'+
			'</a>';
	}
	
	rHtml = ''+
		'<li class="aItem" autoId="' + t.autoId + '" id="autoId_' + t.autoId + '">'+
			fHtml+
			'<a class="body" doType="comm" autoId="' + t.autoId + '">'+
				'<img class="avatar" src="img/avatar.jpg" onui="'+ t.avatImui +'">'+
				'<div class="name tow"><font class="me">'+ t.nickName + '</font></div>'+
				'<div class="time tow"><font class="tm">'+ inc.dateFormat(t.showtime,'d') +'</font></div>'+
				pHtml+
				'<div class="text">'+ t.commText +'</div>'+
			'</a>'+
			sHtml+
			aHtml+
		'</li>';
	return rHtml;
}
inc.sameTalkListHtml = function (y) {
	var yHtml = '';
	if (y.isPast) {
		yHtml = ''+
			'<li class="bItem" autoId="'+ y.autoId +'" id="autoId_'+ y.autoId +'">'+
				'<div class="block" autoId="'+ y.autoId +'" doType="past">'+
					'<font class="n8">'+ y.nickName + ' : '+ y.commText +'</font>'+
					'<font class="tm">'+ inc.dateFormat(y.maketime,'d') +'</font>'+
				'</div>'+
			'</li>';
	} else if (y.isSend) {
		yHtml = ''+
			'<li class="bItem" autoId="'+ y.autoId +'" id="autoId_'+ y.autoId +'">'+
				'<a class="block" autoId="'+ y.autoId +'" doType="send">'+
					'<font class="n8">'+ '我' + ' : '+ y.commText +'</font>'+
					'<font class="tm">'+ inc.dateFormat(y.maketime,'d') +'</font>'+
				'</a>'+
			'</li>';
	}
	return yHtml;
}
/***评论和单聊列表*********************************************************************************/
/***修改统计数*********************************************************************************/
inc.nicePercent = function (isnices,unnices,isZero) {
	isnices  = inc.anyToInt( isnices );
	unnices  = inc.anyToInt( unnices );
	var percent;
	if (isnices >= 1) {
		percent = isnices / (isnices + unnices);
		percent = inc.anyToFlo(percent*100,0) + '%';
	} else {
		percent = isZero ? 0 : '/不好';
	}
	return percent;
}
inc.pullListDataFire = function(name,detail) {
	inc.winFire('public-child.html'       , name, detail);
	inc.winFire('index-same-child.html'   , name, detail);
	inc.winFire('index-sale-child.html'   , name, detail);
	inc.winFire('aidme-apply-child.html'  , name, detail);
	inc.winFire('index-article-child.html', name, detail);
	inc.winFire('aidme-article-child.html', name, detail);
	inc.winFire('aidme-collect-child.html', name, detail);
	
};
inc.pullListNicesAlter = function(detail,winArr) {
	//detail = {saleId:r.saleId, artiId:r.artiId, isnices:r.isnices, unnices:r.unnices};
	if (winArr && inc.isArray(winArr)) {
		for (var i=0,len=winArr.length;i<len;i++) {
			inc.winFire(winArr[i], 'pullListNicesAlter', detail);
		}
	}
	inc.pullListDataFire('pullListNicesAlter',detail);
};
inc.pullListLikesAlter = function(detail,winArr) {
	//detail = {saleId:r.saleId, artiId:r.artiId, likes:r.likes};
	if (winArr && inc.isArray(winArr)) {
		for (var i=0,len=winArr.length;i<len;i++) {
			inc.winFire(winArr[i], 'pullListLikesAlter', detail);
		}
	}
	inc.pullListDataFire('pullListLikesAlter',detail);
};
inc.pullListCollectsAlter = function(detail,winArr) {
	//detail = {saleId:r.saleId, artiId:r.artiId, collects:r.collects};
	if (winArr && inc.isArray(winArr)) {
		for (var i=0,len=winArr.length;i<len;i++) {
			inc.winFire(winArr[i], 'pullListCollectsAlter', detail);
		}
	}
	inc.pullListDataFire('pullListCollectsAlter',detail);
};
inc.pullListCommentsAlter = function(detail,winArr) {
	//detail = {saleId:r.saleId, artiId:r.artiId, comments:r.comments};
	if (winArr && inc.isArray(winArr)) {
		for (var i=0,len=winArr.length;i<len;i++) {
			inc.winFire(winArr[i], 'pullListCommentsAlter', detail);
		}
	}
	inc.pullListDataFire('pullListCommentsAlter',detail);
};
inc.pullListArticleAlter = function(detail,winArr) {
	//detail = {saleId:r.saleId, artiId:r.artiId, sameTitle:r.sameTitle, sameImid:r.sameImid};
	if (winArr && inc.isArray(winArr)) {
		for (var i=0,len=winArr.length;i<len;i++) {
			inc.winFire(winArr[i], 'pullListArticleAlter', detail);
		}
	}
	inc.pullListDataFire('pullListArticleAlter',detail);
};
/***修改统计数*********************************************************************************/
/***拉黑或解除拉黑*********************************************************************************/
/**
 * aidto  - 拉黑对象
 * doType - toDo=拉黑 unDo=解除
 * */
inc.defriend = function (a,callbackS,callbackE) {
	if ( !inc.isLogin(true) ) return;
	
	var fun = {};
		fun.xhrRet = function(xhrRet) {
			//inc.isDevelop && console.log( 'xhrRet-' + xhrRet.retData );
			var retObj = inc.ajax.xhrToEval(xhrRet.retData);
			if (retObj.retStr === 'ok') {
				var SuObj = inc.storageItemGet('SuObj','object');
					SuObj.defriendStr = inc.anyToStr( retObj.lists.defriendStr );
				inc.storageItemSet('SuObj',SuObj);
					
				inc.showLoadMid(false);
				a.doType === 'toDo' ? inc.showToast('拉黑成功') : inc.showToast('解除成功');
				callbackS && callbackS.call(a,a);
			}else{
			    inc.showLoadMid(false);
			    //返回错误信息
			    var retErr = inc.ajax.errorFirst(retObj.retStr);
			    if ( retErr === false ) {
			    	if (retObj.retStr === 'error_aidto_notSelf') {
			    		inc.showAlert( '不能拉黑自己' );
			    	} else if (retObj.retStr === 'error_aidto_wrong') {
			    		inc.showAlert( '用户不存在' );
			    	} else if (retObj.retStr === 'error_aidto_isSystem') {
			    		inc.showAlert( '不能拉黑[系统消息]用户' );
			    	} else if (retObj.retStr === 'error_doType_wrong') {
			    		inc.showAlert( '操作类型不正确' );
			    	} else {
			    		inc.ajax.errorFinal(retObj.retStr);
			    	}
			    }
			}
		};
    inc.showLoadMid(true,"提交中...");
	inc.ajax.send({
		xUrl : inc.urls.defriend,
		data : {
			aidto  : a.aidto,
			doType : a.doType,
		}
	},fun.xhrRet,function(e){
		inc.showAlert( inc.printObj(e) );
	});
};
/***拉黑或解除拉黑*********************************************************************************/
/***打开外链*************************************************************************************/
inc.outerLinkToOpen = function(a) {
	var p = {};
		p.outerTitle = a.outerTitle || '';
		p.outerLink  = a.outerLink  || '';
		p.lowerLink  = p.outerLink;
		p.lowerLink  = p.lowerLink.toLowerCase();
	if (a.isOpen === 'false' || a.isOpen === false || a.isopen === 'false' || a.isopen === false) {
		p.isOpen = false;
	} else {
		p.isOpen = true;
	}
	//inc.isDevelop && console.log( inc.printObj(p) );
	if (inc.isEmptyVal(p.outerLink)) {
		inc.showToast('链接为空值');
		return;
	}
	if (p.isOpen) {
		if (p.lowerLink.indexOf('.taobao.') !== -1 || p.lowerLink.indexOf('.tmall.') !== -1) {
			p.outerTitle = '商品';
			if (inc.isAndroid()) {
				if (plus.runtime.isApplicationExist({pname:'com.taobao.taobao',action:'taobao://'})) {
					plus.runtime.openURL(p.outerLink,function(e){
						//inc.isDevelop && console.log('e-'+inc.printObj(e));
						inc.winOpen('outerLink.html',{outerLink:p.outerLink,outerTitle:p.outerTitle});
					},'com.taobao.taobao');
				} else {
					inc.winOpen('outerLink.html',{outerLink:p.outerLink,outerTitle:p.outerTitle});
				}
			} else {
				p.urlscheme = null;
				if (p.lowerLink.substr(0,7) === 'http://') {
					p.urlscheme = 'taobao://' + p.outerLink.substr(7);
				} else if (p.lowerLink.substr(0,8) === 'https://') {
					p.urlscheme = 'taobao://' + p.outerLink.substr(8);
				}
				plus.runtime.launchApplication({
					pname  : 'com.taobao.taobao',
					action : p.urlscheme
				}, function(e){
					//inc.isDevelop && console.log('e-'+inc.printObj(e));
					inc.winOpen('outerLink.html',{outerLink:p.outerLink,outerTitle:p.outerTitle});
				});
			}
		} else {
			inc.winOpen('outerLink.html',{outerLink:p.outerLink,outerTitle:p.outerTitle});
		}
	} else {
		inc.winOpen('outerLink.html',{outerLink:p.outerLink,outerTitle:p.outerTitle});
	}
};
/***打开外链*************************************************************************************/
/***持续时间*************************************************************************************/
/**
 * 特别注意：时间单位都是毫秒
 * startime=加载起始时间，单位毫秒
 * longtime=设置持续时间，单位毫秒
 * */
inc.longToTime = function(startime,longtime) {
	var p = {};
		p.startime = startime;
		p.longtime = typeof longtime === 'number' ? longtime : 777;
		p.skiptime = p.longtime;//剩余跳转时间
		p.currtime = inc.localtime(true);//当前时间
	if (typeof p.startime === 'number' && typeof p.longtime === 'number' && typeof p.currtime === 'number') {
		p.middtime = p.currtime - p.startime;
		if (p.middtime >= 0) p.skiptime = p.middtime <= p.longtime ? p.longtime - p.middtime : 0;
	}
	//inc.isDevelop && console.log( 'p.startime-' + p.startime );
	//inc.isDevelop && console.log( 'p.currtime-' + p.currtime );
	//inc.isDevelop && console.log( 'p.longtime-' + p.longtime );
	//inc.isDevelop && console.log( 'p.middtime-' + p.middtime );
	//inc.isDevelop && console.log( 'p.skiptime-' + p.skiptime );
	return p.skiptime;
};
/***持续时间*************************************************************************************/
/***背景代码*************************************************************************************/
inc.listDownHtml = function(name) {
	name = name || '';
	return '<div class="inc-listDown '+name+'"><span class="mui-spinner mui-spinner-white"></span></div>'
};
inc.listFakeHtml = function(name) {
	name = name || '';
	var kHtml = '<li>'+
					'<div class="a"></div>'+
					'<div class="b"><div class="b0 b1"></div><div class="b0 b2"></div></div>'+
					'<div class="c"><div class="c0 c1"></div><div class="c0 c2"></div>'+
						'<div class="c0 c3"></div><div class="c4"></div></div>'+
					'<div class="d"></div>'+
				'</li>';
	return '<div class="inc-listFake '+name+'"><ul>'+
			kHtml+kHtml+kHtml+kHtml+kHtml+kHtml+kHtml+kHtml+kHtml+'</ul></div>';
};
/***背景代码*************************************************************************************/
/***更新应用*************************************************************************************/
inc.appInstall = function(isForce) {
	var SlinkSave = inc.storageItemGet('SlinkSave','object');
	var fun = {};
		fun.showConfirm = function() {
			inc.showConfirmSureCancel({
				title   : '特价买手',
				content : SlinkSave.instText || ('更新至最新版本 ' + SlinkSave.version),
				sure    : '现在更新'
			},function(s){
				fun.appInstall();
			});
		};
		fun.appInstall  = function() {
			if (inc.isAndroid()) {
				if (SlinkSave.apkLink) {
					inc.fileDownloadOne({
						fileImui  : SlinkSave.apkLink,
						saveDoc   : inc.fileCreateDoc('apk',SlinkSave.version,'apk'),
						onChanged : inc.fileDownloadOnChanged,
					},function(s){
						plus.runtime.install(s.fileDoc);
					},function(e){
						inc.showToast('下载安装包失败，请重新尝试');
					});
				} else {
					inc.showToast('下载链接不存在');
				}
			} else {
				if (SlinkSave.iosLink) {
					plus.runtime.openURL(SlinkSave.iosLink);
				} else {
					inc.showToast('下载链接不存在');
				}
			}
		};
	if (isForce) {
		fun.appInstall();
	} else {
		if (inc.isAndroid()) {
			if (SlinkSave.apkLink) {
				fun.showConfirm();
			}
		} else {
			if (SlinkSave.iosLink) {
				fun.showConfirm();
			}
		}
	}
};
/* *
 * 版本号三位两个点 1.1.1，
 * 返回三个值 
 * NULL=传入值错误
 * true = new >  old
 * false= new <= old
 * echo compareOldNewVersion('1.1.1','1.2.3',0) === NULL;
 * */
inc.compareOldNewVersion = function(old,nov,digit) {
		old   = inc.anyToStr(old);
		nov   = inc.anyToStr(nov);
	var oArr  = inc.split(old,'.');
	var nArr  = inc.split(nov,'.');
	var oLen  = oArr.length;
	var nLen  = nArr.length;
		digit = inc.anyToInt(digit);
	if (oLen >=2 && nLen >=2 && digit >= 1) {
		var isNew = false;
		if (old == nov) {
			isNew = false;
		} else {
			for (var i=0;i<digit;i++) {
				var oInt = inc.anyToInt( oArr[i] );
				var nInt = inc.anyToInt( nArr[i] );
				if (nInt > oInt) {
					isNew = true;
					break;
				} else if (nInt < oInt) {
					isNew = false;
					break;
				}
			}	
		}
		return isNew;
	} else {
		return null;
	}
};
/***更新应用*************************************************************************************/
//补零-保留几位小数点-imid网络文件路径
inc.zeroArr = [
	'',
	'0',
	'00',
	'000',
	'0000',
	'00000',
	'000000',
	'0000000',
	'00000000',
	'000000000',
	'0000000000',
	'00000000000',
	'000000000000',
];
//是否为数组
inc.isArray = function(obj) {
	return Array.isArray ? Array.isArray(obj) : obj instanceof Array;
};
//是否为函数
inc.isFunction = function(obj) {
	return typeof obj === 'function';
};
//这里定义null不是对象
inc.isObject = function(obj) {
	return obj ? typeof obj === 'object' : false;
};
//简单复制json
inc.copyJson = function(a){
	var o = {};
	if (a && typeof a === 'object') {
		for (var i in a) {
			o[i] = a[i];
		}
	}
	return o;
};
//非对象为空对象
inc.isEmptyObj = function(obj) {
	if (typeof obj === 'object') {
		//for..in..对字符串和对象有效，但对数字、null、undefined无效
		for (var p in obj) {
			if (p !== undefined) {
				return false;
			}
		}
	}
	return true;
};
//定义字符串中单个0为空值
inc.isEmptyVal = function(s){
	if (typeof s === 'string') {
		s = inc.delBrNbspSpaceAll(s);
		return (s === '' || s === '0') ? true : false;
	}
	return s ? false : true;
};
inc.isLett = function(v) {
	var re=/^[a-zA-Z]+$/;
	return v.search(re) === -1 ? false : true;
};
inc.isNum = function(v) {
	var re=/^[0-9]+$/;
	return v.search(re) === -1 ? false : true;
};
inc.isFloat = function(v) {
	var re=/^[0-9\.]+$/;
	return v.search(re) === -1 ? false : true;
};
//检查单个字符为中文//例如输入姓氏
inc.isChinese = function(v) {
	//创建正则表达式
	var re=/^[\u4e00-\u9fa5]+$/; //只输入汉字的正则
	return v.search(re) === -1 ? false : true;
};
inc.isLettNum = function(v) {
	var re = /^[a-zA-Z0-9]+$/;
	return v.search(re) === -1 ? false : true;
};
inc.isLettNumUnline = function(v) {
	var re = /^[a-zA-Z0-9_]+$/;
	return v.search(re) === -1 ? false : true;
};
inc.isLettNumLine = function(v) {
	var re = /^[a-zA-Z0-9_\-]+$/;
	return v.search(re) === -1 ? false : true;
};
inc.isChinLettNumLine = function(v){
	var re = /^[a-zA-Z0-9_\-\u4e00-\u9fa5]+$/;
	return v.search(re) === -1 ? false : true;
};
inc.isEmail = function(v) {
	//创建正则表达式
	//var re=/^[A-Za-z0-9\-_\.@]{6,50}$/;
	var re = /^\w+([-+.']\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*$/;
	return v.search(re) === -1 ? false : true;
};
inc.isPassword = function(v) {
	//创建正则表达式
	var re=/^[\-_0-9a-zA-Z]{6,18}$/;
	return v.search(re) === -1 ? false : true;
};
//去掉两边空格//替换掉所有首位空格Trim()
inc.trim = function(s) {
	return inc.anyToStr(s).replace(/(^[\n\s]*)|([\n\s]*$)/g, '');
};
//将所有连在一起的空格和换行符替换为1个空格
inc.delBrNbspSpaceOne = function(s){
	return inc.trim(s).replace(/(\n|\s|&nbsp;|<br>)+/ig,' ');
};
//将所有空格和换行符全部删除
inc.delBrNbspSpaceAll = function(s){
	return inc.trim(s).replace(/(\n|\s|&nbsp;|<br>)+/ig,'');
};
inc.split = function(a,b) {
	if (inc.isArray(a)) return a;
	a = inc.anyToStr(a);
	b = b || '';
	return a ? a.split(b) : [];
};
inc.join = function(a,b) {
	a = inc.isArray(a) ? a : [];
	b = b || '';
	return a.length >= 1 ? a.join(b) : '';
};
inc.remove = function(a,v) {
	var r = [];
	if (inc.isArray(a)) {
		for (var i=0;i<a.length;i++) {
			if (a[i] !== v) {
				r.push(a[i]);
			}
		}	
	}
	return r;
};
//t=i数字比较 t=s字符串 默认为i
inc.equal = function(a,b,t) {
	return t === 's' ? inc.anyToStr(a) === inc.anyToStr(b) : inc.anyToInt(a) === inc.anyToInt(b);
};
inc.anyToInt = function(s) {
	var i = parseInt(s,10);
	return !isNaN(i) ? i : 0;
};
/**
 * n=保留小数点后固定位数，如果n=未定义或不为数字类型则直接使用parseFloat
 * b=true四舍五入，false=舍位，默认为true
 * 注意：toFixed返回字符串类型
 * */
inc.anyToFlo = function(s,n,b) {
	var r,i; 
		i = parseFloat(s,10);
		i = !isNaN(i) ? i : 0;
	if (typeof n !== 'number') {
		r = i; //原样返回
	} else {
		var add  = 0;
		var temp = Math.pow(10,n);
			b    = typeof b === 'boolean' ? b : true;
		if (b) {
			var ss    = '' + i + '';
			var start = ss.indexOf(".");
			var add   = 0;
			if (start !== -1) {
				add   = inc.anyToInt( ss.substr(start + n + 1, 1) ) >= 5 ? 1 : 0;
			}
		}
		var end = Math.floor(i * temp) + add;
		//toFixed-返回字符串类型
		r = (end/temp).toFixed(n);
	}
	return r;
};
/**
 * 保留1位小数点，但小数点第一位为0时舍弃
 * */
inc.anyToF01 = function(s) {
	var f0 = parseFloat( inc.anyToFlo( s,0,false ) );
	var f1 = parseFloat( inc.anyToFlo( s,1,false ) );
	return f0 == f1 ? f0 : f1;
};
//b=true时0转为空值
inc.anyToStr = function(s,b) {
	var t = typeof s;
	if (t === 'string') {
		return b ? ( !inc.isEmptyVal(s) ? s : '' ) : s;
	}else{
		if (t === 'number') {
			s = !isNaN(s) ? s.toString() : '';
			return b ? ( !inc.isEmptyVal(s) ? s : '' ) : s;
		}
	}
	return '';
};
//数字转万，保留一位小数点//isZero=true显示0，=false显示空
inc.intToWan = function(v,isZero) {
	v = inc.anyToInt(v);
	v = v >= 10000 ? ( (v/10000).toFixed(1) ) + '万' : v;
	return isZero ? v : ( v ? v : '' );
};
/**
 * 保留汉字、字母、数字、-、—
 * 一个中文为2个字符，最多14个字符
 * */
inc.holdNickName = function(v){
	var aArr = inc.split(inc.anyToStr(v),'');
	var aLen = aArr.length;
	var tArr = [];
	var cLen = 0;
	for (var i=0;i<aLen;i++) {
		if ( inc.isChinLettNumLine(aArr[i]) ) {
			tArr.push(aArr[i]);
			if ( inc.isChinese(aArr[i]) ) {
				cLen += 2;
			} else {
				cLen += 1;
			}
			if (cLen >= 14) {
				break;
			}
		}
	}
	return inc.join(tArr,'');
};
/**
 * isExec=true-仅仅执行字符串语句-false=解析为对象
 */
inc.strToEval = function(str,isArr,isExec) {
	if (isExec) {
		var ret = true;
		try {
			eval('(' + str + ')');
		} catch(e) {
			ret = false;
		}
		return ret;
	} else {
		var ret = isArr ? [] : {};
		if (typeof str === 'string' && !inc.isEmptyVal(str)) {
			try {
				ret = eval('(' + str + ')');
			} catch(e) {
				ret = ret;
			}
		} else if (typeof str === 'object' && str) {
			ret = str;
		}
		return ret;
	}
};
//str不能为纯数字//li[id=data]data不能为纯数字
inc.strToEle = function(str) {
	if(str && typeof(str) === 'string'){
		return document.querySelector(str);
	}else{ return str && typeof str === 'object' ? str : null; }
};
//获取标签属性值
inc.attrGet = function(id,name) {
	var ele = inc.strToEle(id);
	return ele ? ele.getAttribute(name) : null;
};
//设置或修改标签属性
inc.attrSet = function(id,name,value) {
	var ele = inc.strToEle(id);
		ele && ele.setAttribute(name,value);
};
inc.classListContains = function(id,name) {
	var ele = inc.strToEle(id);
	if (ele) return ele.classList.contains(name);
	return false;
};
inc.classListAdd = function(id,name) {
	var ele = inc.strToEle(id);
	if ( ele && !ele.classList.contains(name) ) ele.classList.add( name );
};
inc.classListRemove = function(id,name) {
	var ele = inc.strToEle(id);
	if ( ele &&  ele.classList.contains(name) ) ele.classList.remove( name );
};
/*
 * 全部子节点
 * */
inc.elementChildNodes = function(id) {
	var ele = inc.strToEle(id);
	var ret = [];
	if (ele) {
		var arr = ele.children || ele.childNodes;
		for(var i=0,len=arr.length;i<len;i++){
			if(arr[i].nodeType == 1){
				ret.push(arr[i]);
			}
		}
	}
	return ret;
};
/*
 * 第一个子节点
 * */
inc.elementFirstChild = function(id) {
	var arr = inc.elementChildNodes(id);
	var len = arr.length;
	return len >= 1 ? arr[0] : undefined;
};
/*
 * 最后一个子节点
 * */
inc.elementLastChild  = function(id) {
	var arr = inc.elementChildNodes(id);
	var len = arr.length;
	return len >= 1 ? arr[len - 1] : undefined;
};
/*
 * 上一兄弟节点
 * */
inc.previousElementSibling = function(id) {
	var ele = inc.strToEle(id);
	var ret = undefined;
	if (ele) {
		if (ele.previousElementSibling !== undefined) {
			ret = ele.previousElementSibling;
		} else {
			ret = ele.previousSibling;
			while(ret && ret.nodeType != 1){
				ret = ret.previousSibling;
			}
		}
	}
	return ret;
}
/*
 * 下一兄弟节点
 * */
inc.nextElementSibling = function(id) {
	var ele = inc.strToEle(id);
	var ret = undefined;
	if (ele) {
		if (ele.nextElementSibling !== undefined) {
			ret = ele.nextElementSibling;
		} else {
			ret = ele.nextSibling;
			while(ret && ret.nodeType != 1){
				ret = ret.nextSibling;
			}
		}
	}
	return ret;
}
/**
 * 创建蒙板，该函数来自 mui.createMask
 * */
inc.createMask = function(aClass,aCallback) {
	var M = {}; //M=mui
		M.EVENT_MOVE = 'touchmove';
		M.preventDefault = function(e) {
			e.preventDefault();
		};
	
	var mClass,callback;
	if (typeof aClass === 'function') {
		mClass   = null;
		callback = aClass;
	} else {
		mClass   = aClass;
		callback = aCallback;
	}
		mClass = mClass || 'inc-mask';
	if (mClass.length == 1) {
		mClass = 'inc-mask' + mClass;
	}
	
	var element = document.createElement('div');
		element.classList.add(mClass);
		element.addEventListener(M.EVENT_MOVE, M.preventDefault);
		element.addEventListener('tap', function() {
			mask.close();
		});
	var mask = [element];
	mask._show = false;
	mask.show = function() {
		mask._show = true;
		element.setAttribute('style', 'opacity:1');
		document.body.appendChild(element);
		return mask;
	};
	mask._remove = function() {
		if (mask._show) {
			mask._show = false;
			element.setAttribute('style', 'opacity:0');
			element.parentNode === document.body && document.body.removeChild(element);
		}
		return mask;
	};
	mask.close = function() {
		if (callback) {
			if (callback() !== false) {
				mask._remove();
			}
		} else {
			mask._remove();
		}
	};
	return mask;
};
//例如 data="goHtml*|*=*|*owner-edit.html*|*,*|*ownerTelephone*|*=*|*13777469001"
inc.dataStrToObj = function(s,t) {
	t = t ? t : 'a';
	var equal = '=', split = '&';
	if (t === 'a') {
		equal = '=';
		split = '&';
	} else if (t === 'b') {
		equal = '*|*=*|*';
		split = '*|*&*|*';
	}
	var dArr = inc.split(s,split), o = {}, vArr = [];
	for (var i=0;i<dArr.length;i++) {
		vArr = inc.split(dArr[i],equal);
		if (vArr.length == 2) o[vArr[0]] = vArr[1];
	}
	return o;
};
//例如 data="goHtml*|*=*|*owner-edit.html*|*,*|*ownerTelephone*|*=*|*13777469001"
inc.dataObjToStr = function(o,t) {
	t = t ? t : 'a';
	var equal = '=', split = '&';
	if (t === 'a') {
		equal = '=';
		split = '&';
	} else if (t === 'b') {
		equal = '*|*=*|*';
		split = '*|*&*|*';
	}
	var aArr = [];
	for (var p in o) {
		aArr.push(p + equal + o[p]);
	}
	return aArr.join(split);
};
inc.createElem = function(a) { 
    var r = []; 
    //如果参数不是数组，强行转换 
    if (!inc.isArray(a)) a = [a]; 
    for (var i = 0; i < a.length; i++) { 
        if (a[i].constructor == String) { 
            //用一个临时变量存放HTML 
            var div = document.createElement("div");
            //注入HTML，转换成DOM结构 
            div.innerHTML = a[i]; 
            //提取DOM结构到临时div中 
            for (var j = 0; j < div.childNodes.length; j++) 
                r[r.length] = div.childNodes[j]; 
        } else {
	        if (a[i].length) {
	            // 假定是DOM节点数组 
	            for (var j = 0; j < a[i].length; j++) 
	                r[r.length] = a[i][j]; 
	        } else { 
	            //否则假定是DOM节点 
	            r[r.length] = a[i]; 
	        }
        }
    } 
    return r; 
};
//在eleA节点内的eleC节点前插入节点eleB
inc.htmlPrepend = function(eleA,eleB,eleC) {
	eleA = inc.strToEle(eleA);
	if (eleA && eleB) {
		eleC = inc.strToEle(eleC);
		eleC = eleC ? eleC : ( inc.elementFirstChild(eleA) || null);
		//获取元素的新数组
		var eles = inc.createElem(eleB);
		if (eleC) {
			//向前遍历数组，因为我们向前插入元素 
			for (var i=0;i<eles.length;i++) {
				eleA.insertBefore(eles[i], eleC);
			}
		} else {
			//向后遍历数组，因为我们向前插入元素 
			for (var i=eles.length-1;i>=0;i--) {
				eleA.insertBefore(eles[i], eleC);
			}
		}
	}
};
//在eleA节点内的尾部插入节点eleB
inc.htmlAppend = function(eleA,eleB) {
	eleA = inc.strToEle(eleA);
	if(eleA && eleB){
		//获取元素的新数组
	    var eles = inc.createElem(eleB); 
	    for (var i = 0; i < eles.length; i++) { 
	        eleA.appendChild(eles[i]); 
	    } 
	}
};
//覆盖内容
inc.htmlSet = function(id,html){
	var ele = inc.strToEle(id);
	if (ele) ele.innerHTML = html;
}
inc.htmlShow = function(id) {
	var ele = inc.strToEle(id);
	if (ele) ele.style.display = "block";
};
inc.htmlHide = function(id,remove) {
	var ele = inc.strToEle(id);
	if (ele) ele.style.display = "none";
	if (ele && remove && ele.parentNode) ele.parentNode.removeChild(ele);
};
/**
 * 由于css设置的display获取不到，即使css中设置了，在初始 ele.style.display 的值也为 null
 * isShow=true 默认初始状态显示，false=默认初始状态隐藏
 * 如果isShow不传入任何值，则默认初始显示
 * */
inc.htmlShowHide = function(id,isShow){
	var ele = inc.strToEle(id);
	if (!ele) return;
	var display = ele.style.display;
	if (typeof isShow === 'undefined') {
		ele.style.display = !display || display === 'none' ? 'block' : 'none';
	} else {
		if (!display) {
			ele.style.display = isShow ? 'block' : 'none';
		} else {
			ele.style.display = display === 'none' ? 'block' : 'none';
		}
	}
};
inc.lineShow = function(id) {
	var ele = inc.strToEle(id);
	if (ele) ele.style.display = "inline-block";
};
inc.lineHide = function(id,remove) {
	var ele = inc.strToEle(id);
	if (ele) ele.style.display = "none";
	if (ele && remove && ele.parentNode) ele.parentNode.removeChild(ele);
};
/**
 * 由于css设置的display获取不到，即使css中设置了，在初始 ele.style.display 的值也为 null
 * isShow=true 默认初始状态显示，false=默认初始状态隐藏
 * 如果isShow不传入任何值，则默认初始显示
 * */
inc.lineShowHide = function(id,isShow){
	var ele = inc.strToEle(id);
	if (!ele) return;
	var display = ele.style.display;
	if (typeof isShow === 'undefined') {
		ele.style.display = !display || display === 'none' ? 'inline-block' : 'none';
	} else {
		if (!display) {
			ele.style.display = isShow ? 'inline-block' : 'none';
		} else {
			ele.style.display = display === 'none' ? 'inline-block' : 'none';
		}
	}
};
inc.valueSet = function(id,val) {
	var ele = inc.strToEle(id);
	if (ele && ( ele.tagName === 'INPUT' || ele.tagName === 'TEXTAREA' ) ) ele.value = val;
};
inc.valueGet = function(id) {
	var ele = inc.strToEle(id), val = '';
	if (ele && ( ele.tagName === 'INPUT' || ele.tagName === 'TEXTAREA' ) ) val = ele.value;
	return val;
};
inc.optionSelected = function (id,val) {
	var ele = inc.strToEle(id);
	if (!ele) return false;
	var tag = false;
	for(var i=0;i<ele.options.length;i++){
		if( inc.anyToStr(ele.options[i].value) === inc.anyToStr(val) ) {
			ele.options[i].selected = true;
			tag = true;
			break;
		}
	}
	return tag;
};
inc.optionSelectedValue = function (id){
	var ele = inc.strToEle(id);
	if (!ele) return '';
	var tag = false,val = '';
	for(var i=0;i<ele.options.length;i++){
		if(ele.options[i].selected) {
			tag = true;
			val = ele.options[i].value;
			break;
		}
	}
	return tag ? val : '';
};
inc.optionSelectedText = function (id){
	var ele = inc.strToEle(id);
	if (!ele) return '';
	var tag = false,val = '';
	for(var i=0;i<ele.options.length;i++){
		if(ele.options[i].selected) {
			tag = true;
			val = ele.options[i].text;
			break;
		}
	}
	return tag ? val : '';
};
inc.radioCheckedId = function(id) {
	var ele = inc.strToEle(id);
	var ret = [];
		ret.value = '';
	if (ele) {
		ele.checked = true;
		ret.push(ele);
		ret.value = ele.value;
	}
	return ret;
};
inc.radioCheckedName = function (name,value){
	//如果name不存在则返回空数组
	var radios = document.getElementsByName(name);
	var ret = [], vArr = [];
	var fun = {};
		fun.checked = function(radios,value) {
			for (var i=0;i<radios.length;i++) {
				if ( inc.anyToStr(radios[i].value) === inc.anyToStr(value) ) {
					radios[i].checked = true;
					 ret.push(radios[i]);
					vArr.push(radios[i].value);
					break;
				}
			}
		};
	if ( inc.isArray(value) ) {
		for (var i=0;i<value.length;i++) {
			fun.checked(radios,value[i]);
		}
	} else {
		fun.checked(radios,value);
	}
	ret.value = inc.join(vArr,',');
	return ret;
};
//将所有重置为未选择状态
inc.radioCheckedClean = function (name){
	var radios = document.getElementsByName(name);
	var ret = [];
	for (var i=0;i<radios.length;i++) {
		radios[i].checked = false;
		ret.push(radios[i]);
	}
	return ret;
};
inc.radioCheckedValue = function(name) {
	var radios = document.getElementsByName(name);
	var ret = [],vArr = [];
	for (var i=0;i<radios.length;i++) {
		if(radios[i].checked) {
			 ret.push(radios[i]);
			vArr.push(radios[i].value);
		}
	}
	ret.value = inc.join(vArr,',');
	return ret;
};
//格式化js时间
/** * 对Date的扩展，将 Date 转化为指定格式的String * 月(M)、日(d)、12小时(h)、24小时(H)、分(m)、秒(s)、周(E)、季度(q)
    可以用 1-2 个占位符 * 年(y)可以用 1-4 个占位符，毫秒(S)只能用 1 个占位符(是 1-3 位的数字) 
 * eg: * (newDate()).format("yyyy-MM-dd hh:mm:ss.S")==> 2006-07-02 08:09:04.423      
 * (new Date()).format("yyyy-MM-dd E HH:mm:ss") ==> 2009-03-10 二 20:09:04      
 * (new Date()).format("yyyy-MM-dd EE hh:mm:ss") ==> 2009-03-10 周二 08:09:04      
 * (new Date()).format("yyyy-MM-dd EEE hh:mm:ss") ==> 2009-03-10 星期二 08:09:04      
 * (new Date()).format("yyyy-M-d h:m:s.S") ==> 2006-7-2 8:9:4.18      
 */        
Date.prototype.format = function(format) {
	var o = {
	"M+" : this.getMonth()+1, //月份
	"d+" : this.getDate(), //日
	"h+" : this.getHours(), //小时
	"m+" : this.getMinutes(), //分
	"s+" : this.getSeconds(), //秒
	//"q+" : Math.floor((this.getMonth()+3)/3), //季度
	"S" : this.getMilliseconds() //毫秒
	};
	//var week = {"0":"/u65e5","1":"/u4e00","2":"/u4e8c","3":"/u4e09","4":"/u56db","5":"/u4e94","6":"/u516d"};
	var week = {"0":"日","1":"一","2":"二","3":"三","4":"四","5":"五","6":"六"};
	if(/(y+)/.test(format)){
		format = format.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
	}         
	if(/(E+)/.test(format)){
/*		format = format.replace(RegExp.$1, ((RegExp.$1.length>1) ? (RegExp.$1.length>2 ? "/u661f/u671f" : "/u5468") : "")+week[this.getDay()+""]);*/
		format = format.replace(RegExp.$1, ((RegExp.$1.length>1) ? (RegExp.$1.length>2 ? "星期" : "周") : "") + week[this.getDay() + ""]);
	}
	for(var k in o){
		if(new RegExp("(" + k + ")").test(format)){
			format = format.replace(RegExp.$1, RegExp.$1.length == 1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length));
		}
	}
	return format;
}
/**
 * toTime=1、10位数及以下为秒数。2、10位以上为毫秒数
 * toType=1、长度为一位的字母即指定时间格式类型。2、直接指定日期格式-例如-MM/dd-MM.dd
 * */
inc.dateFormat = function(toTime,toType) {
	toTime = inc.anyToInt(toTime);
	toType = toType || 'a';
	var toTime = ("" + toTime).length <= 10 ? toTime*1000 : toTime;
	var toDate = new Date();
		toDate.setTime(toTime);
	var moDate = new Date();
		moDate.setHours(0,0,0,1);
	var morning = moDate.getTime();//今天凌晨时间
	
	var retStr = '';
	if (toType && typeof toType === 'string' && toType.length >= 2) {
		retStr = toDate.format(toType);
	} else {
		switch(toType){
			case 'a':
				retStr = toDate.format("MM/dd hh:mm");
			break;
			case 'b':
				retStr = toDate.format("yyyy/MM/dd hh:mm");
			break;
			case 'c':
				retStr = toTime > morning ? toDate.format("hh:mm") : toDate.format('MM/dd');
			break;
			case 'd':
				retStr = toTime > morning ? toDate.format("hh:mm") : toDate.format("MM月dd日");
			break;
			case 'e':
				retStr = toTime > morning ? toDate.format("hh:mm") : toDate.format("MM/dd hh:mm");
			break;
			default:
				retStr = toDate.format("MM/dd hh:mm");
		}
	}
	return retStr;
};
//t=true时取到毫秒否则秒
inc.localtime = function(t) {
	return t ? (new Date()).getTime() : Math.ceil((new Date()).getTime()/1000);
};
/**
 * boolean/string/number/object/function/undefined
 * 递归打印对象所有属性
 * nArr 中的属性不打印
 */
inc.printObj = function(o,nArr) {
	//强制转化为数组
	nArr = typeof nArr === 'string' ? [nArr] : ( inc.isArray(nArr) ? nArr : [] );
	var fun = {};
		fun.isInTo = function (obj){
			//null==undefined Arguments
			var class2type = {
				'[object Object]'    : 'object',
				'[object Array]'     : 'array',
				'[object Arguments]' : 'arguments',
				'[object SQLResultSet]' : 'SQLResultSet',
				'[object SQLResultSetRowList]' : 'SQLResultSet',
			};
			return class2type[{}.toString.call(obj)] ? true : false;
		};
		fun.isNumBool = function (obj) {
			return typeof obj === 'boolean' || (typeof obj === 'number' && !isNaN(obj) );
		};
		fun.start = function (o,r){
			try{
				if (fun.isInTo(o)) {
					r = inc.isArray(o) ? [] : {};
					loopA://需要将循环命名
					for (var pop in o) {
						//nArr 中的属性不打印
						for (var i=0,len=nArr.length;i<len;i++) {
							if (pop === nArr[i]) continue loopA;
						}
						try{
							if (fun.isInTo(o[pop])) {
								r[pop] = fun.start(o[pop],r[pop]);
							}else{
								r[pop] = fun.isNumBool(o[pop]) ? o[pop] : String(o[pop]);
							}
						}catch(e){ r[pop] = 'EB: ' + e.message; }
					}
				}else{ r = fun.isNumBool(o) ? o : String(o); }
			}catch(e){ r = 'EA: ' + e.message; }
			return r;
		};
	return JSON.stringify( fun.start(o) );
};
/**************************************************************************************************
 * 
 * 上述js通用
 * 
 **************************************************************************************************/
//取消浏览器的所有事件，使得active的样式在手机上正常生效
document.addEventListener( "touchstart", function(e) {
	return false;
},false);
function shield() { return false; }
// 取消鼠标右键
document.oncontextmenu = shield;
////H5 plus事件处理
//document.addEventListener( "plusready", function() {
//	//禁止长按复制粘贴
//	document.body.onselectstart = shield;
//},false);
//// DOMContentLoaded事件处理
//document.addEventListener( "DOMContentLoaded", function () {
//	//禁止长按复制粘贴
//	document.body.onselectstart = shield;
//},false);
//判断手机操作系统
inc.isAndroid = function() {
	return plus.os.name === 'Android';
};
//判断手机操作系统
inc.isIOS = function() {
	return plus.os.name === 'iOS';
};
/**
 * 判断是否已经登录，isOpen=true 没有登录则直接打开登录页面
 * */
inc.isLogin = function(isOpen,callbackS) {
	var SuObj = inc.storageItemGet('SuObj','object');
	if (!SuObj.aidme || !SuObj.saltB || !SuObj.codeB) {
		isOpen = typeof isOpen === 'boolean' ? isOpen : false;
		isOpen && inc.winOpen('id-login-third.html');
		return false;
	} else {
		callbackS && callbackS();
		return true;
	}
};
/**
 * 创建指定位数的随机盐
 * */
inc.createSalt = function(len) {
	var letts = ['a','b','c','d','e','f','g','h','i','j',
				 'k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z',
				 'A','B','C','D','E','F','G','H','I','J',
				 'K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'];
	len = len || 32;
	var rsign = '';
	for (var i=1;i<=len;i++) {
		rsign += letts[ Math.floor( letts.length * Math.random() )];
	}
	return rsign;
}
/**
 * 创建指定位数的随机盐+13位毫秒时间转字母
 * */
inc.createRsign = function(len) {
	var letts = ['a','b','c','d','e','f','g','h','i','j',
				 'k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z',
				 'A','B','C','D','E','F','G','H','I','J',
				 'K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'];
	len = len || 32;
	var rsign = '';
	if (len >= 13) {
		var rArr = [],j,s;
		var tArr = inc.split(inc.localtime(true),'');
		for (var i=0;i<tArr.length;i++) {
			j = inc.anyToInt(tArr[i]);
			s = (i%2) == 0 ? letts[j] : letts[j].toUpperCase();
			rArr.push(s);
		}
		rsign = inc.createSalt(len - rArr.length) + inc.join(rArr,'');
	} else {
		rsign = inc.createSalt(len);
	}
	return rsign;
};
/**
 * a.pClass = pre的类名，唯一性
 * a.textId
 * a.cellId
 * 用法1、 inc.preAutoHeightTxt({pClass:'A'});
 * 用法2、 inc.preAutoHeightTxt({tEle:tEle});
 * 用法3、tEle是textarea的类名或id或textarea标签对象，cEle=textarea的父标签， pClass=inc-preAutoHeightPre 或 A
 * 用法3、 inc.preAutoHeightTxt({tEle:tEle,cEle:'cellId',pClass:'pClass'});
 * 用法4、 inc.preAutoHeightTxt({tEle:tEle,cNum:1       ,pClass:'pClass'});
 * 用法5、textarea设置minHeight，内容高度小于minHeight不触发改变输入框高度
 * */
inc.preAutoHeightTxt = function(a) {
	var eles = {}, o = {};
	if (a.pClass && typeof a.pClass === 'string') {
		if (a.pClass.length == 1) {
			o.pClass = 'inc-preAutoHeightPre' + a.pClass;
		} else {
			o.pClass = a.pClass;
		}
	} else {
		o.pClass = 'inc-preAutoHeightPre';
	}
	eles.text = null;
	if (a.tEle) {
		eles.text = inc.strToEle(a.tEle);
	} else {
		if (a.pClass && typeof a.pClass === 'string' && a.pClass.length == 1) {
			eles.text = inc.strToEle('.inc-preAutoHeightTxt' + a.pClass);
		}
	}
	o.cNum    = inc.anyToInt(a.cNum);
	eles.cell = a.cEle ? inc.strToEle(a.cEle) : null;
	/**
	 * str.replace('.',''); 只替换第一点.，如果向替换全文的点.，则用正则替换 str.replace(/\./g,'');//g全文匹配
	 * */
	o.pClass = o.pClass.replace('.','');
	eles.pre = inc.strToEle('.' + o.pClass);//pre动态生成
	//text必须是textarea
	if (eles.text && typeof eles.text === 'object' && eles.text.tagName === 'TEXTAREA') {
		if (eles.cell) {
			eles.cell = eles.cell;
		} else {
			//如果未指定 classCell 则默认为 classText 的父标签
			if (o.cNum === 0 || o.cNum === 1) {
				eles.cell = eles.text.parentNode;
			} else if (o.cNum === 2) {
				eles.cell = eles.text.parentNode.parentNode;
			} else if (o.cNum === 3) {
				eles.cell = eles.text.parentNode.parentNode.parentNode;
			} else if (o.cNum === 4) {
				eles.cell = eles.text.parentNode.parentNode.parentNode.parentNode;
			} else if (o.cNum === 5) {
				eles.cell = eles.text.parentNode.parentNode.parentNode.parentNode.parentNode;
			} else {
				return;
			}
		}
	} else {
		return;
	}
	//用标签对象存储 cellPadding
	if (typeof eles.text.cellPadding !== "number") {
		eles.text.cellPadding = eles.cell.offsetHeight - eles.text.offsetHeight;
	}
	//用标签对象存储 minHeight
	if (typeof eles.text.minHeight !== "number") {
		eles.text.minHeight = inc.anyToInt( eles.text.getAttribute('minHeight') );
	}
	//如果pre不存在则创建并初始化pre的宽度
	if (!eles.pre) {
		eles.pre = document.createElement('pre');
		eles.pre.classList.add( o.pClass );
		document.body.appendChild(eles.pre);
		eles.pre.style.width = eles.text.offsetWidth + 'px';
	}
	/*
	 * i 	执行对大小写不敏感的匹配
	 * g 	执行全局匹配（查找所有匹配而非在找到第一个匹配后停止）
	 * m 	执行多行匹配
	 * */
	eles.pre.innerText = eles.text.value.replace(new RegExp('\n', 'gm'), '\n-') || '-';
	if (eles.text.minHeight < 1 || (eles.text.minHeight >= 1 && eles.pre.offsetHeight >= eles.text.minHeight)) {
		eles.text.style.height =  eles.pre.offsetHeight + 'px';
		eles.cell.style.height = (eles.pre.offsetHeight + eles.text.cellPadding) + 'px';
	}
};
inc.showWaiting = function(title,options) {
	//不设置width和height，可避免在iOS上雪花不上下居中的bug
	//var wh = inc.isAndroid() ? '48px' : '53px';
	return plus.nativeUI.showWaiting(title || '',options || {
		//width    : wh,
		//height   : wh,
		padding    : "8px",
		round      : "8px",
		color      : "#FFF",
		background : "rgba(51,51,51,0.9)",
		style      : "white",
		/*back - 可取值"none"表示截获处理返回键，但不做任何响应；"close"表示截获处理返回键并关闭等待框；"transmit"表示不截获返回键，向后传递给Webview窗口继续处理（与未显示等待框的情况一致）*/
		back       : "none",
	});
};
inc.showAlert = function(message,title,butText) {
	plus.nativeUI.alert( inc.anyToStr(message), function(){}, arguments[1] || '', arguments[2] || '确定' );
};
inc.showToastTout = null;
inc.showToast = function(message,duration,vAlign) {
	var a = (message && typeof message === 'object') ? message : {message:message};
	if (!a.isHtml) {
		duration = duration === 'long' ? 'long' : 'short';
		vAlign   = vAlign || 'bottom';
		plus.nativeUI.toast( inc.anyToStr(a.message), { duration : duration, verticalAlign : vAlign });
	} else {
		var tEle = document.querySelector('.inc-toast-container');
		if (tEle) {
			inc.showToastTout && clearTimeout(inc.showToastTout);
			inc.showToastTout = null;
			document.body.removeChild(tEle);
		}
		var div = document.createElement('div');
			div.innerHTML = ''+
						'<div class="inc-toast-container">'+
							'<span class="inc-toast-message">' + a.message + '</span>'+
						'</div>';
		aEle = div.firstElementChild;
		document.body.appendChild(aEle);
		inc.showToastTout = setTimeout(function(){
	  		document.body.removeChild(aEle);
			inc.showToastTout && clearTimeout(inc.showToastTout);
			inc.showToastTout = null;
		},2000);
	}
};
/**
 * content:"双向删除：删除后双方将从对方通讯录中消失:",title:"删除好友",cancel:"取消",sure:"删除"
 */
inc.showConfirmSure = function(a,callbackS) {
	// 弹出提示信息对话框
	plus.nativeUI.confirm( a.content || '', function(e){
		//确定
		if (e.index == 0) {
			callbackS && callbackS.call(a,e);
		}
	}, a.title || '', [a.sure || '确认'] );
};
inc.showConfirmSureCancel = function(a,callbackS,callbackE) {
	// 弹出提示信息对话框
	plus.nativeUI.confirm( a.content || '', function(e){
		//确定
		if (e.index === 0) {
			callbackS && callbackS.call(a,e);
		} else if (e.index === 1) {
			callbackE && callbackE.call(a,e);
		}
	}, a.title || '', [a.sure || '确认',a.cancel || '取消'] );
};
inc.showPromptSure = function(a,callbackS) {
	// 弹出提示信息对话框
	plus.nativeUI.prompt( a.content || '', function(e){
		//确定
		if (e.index === 0) {
			callbackS && callbackS.call(a,e);
		}
	}, a.title, a.default || '', [a.sure || '确定'] );
};
inc.showPromptSureCancel = function(a,callbackS,callbackE) {
	// 弹出提示信息对话框
	plus.nativeUI.prompt( a.content || '', function(e){
		//确定
		if (e.index === 0) {
			callbackS && callbackS.call(a,e);
		} else if (e.index === 1) {
			callbackE && callbackE.call(a,e);
		}
	}, a.title || '', a.default || '', [a.sure || '确认',a.cancel || '取消'] );
};
/**
 * 选择弹窗
 * a = ["添加","删除"]
 * s.index从1开始，a中的第一个,第二个等 选中后 s.index == 1,2等;
 * */
inc.showActionSheet = function(a,callbackS) {
	var buttons = [];
	a = inc.isArray(a) ? a : [];
	for (var i=0;i<a.length;i++) {
		buttons.push({title:a[i]});
	}
	plus.nativeUI.actionSheet({
		cancel  : '取消',
		buttons : buttons
	},function(s) {
		callbackS && callbackS.call(a,s);
	});
}
/**
 * 选择弹窗
	pub.mask.popSele = inc.showPopSelect({
		mClass : 'A', //蒙版类名
		aClass : '', //链接类名
		isElli : false,//文字截断
		popLis : [
			{
				doType : 'home',
				title  : '查看主页<font color="#BBB">-</font>',
			},
		],
	},function(s) {
		//inc.isDevelop && console.log( 's.doType-' + s.doType );
		if (s.doType === 'home') {
			//
		}
	},function(c) {
		//inc.isDevelop && console.log( '不能再close否则死循环' );
		pub.mask.popSele = null;
	});
 * callbackC-蒙板关闭回调函数
 * */
inc.showPopSelect = function(a,callbackS,callbackC) {
	a.mClass   = a.mClass;
	a.popClass = a.popClass || 'popSelectEdit';
	inc.htmlHide('.' + a.popClass,true);

	var iHtml = '', aClass = '', eClass = '', tClass = '', aStyle = '';
	for (var i=0;i<a.popLis.length;i++) {
		a.popLis[i]['isElli'] = typeof a.popLis[i]['isElli'] === 'boolean' ? a.popLis[i]['isElli'] : true;
		aClass = a.popLis[i]['aClass'] ? ' ' + a.popLis[i]['aClass'] : '';//自定类名
		eClass = a.popLis[i]['isElli'] ? ' mui-ellipsis' : '';//超过范围显示省略号
		tClass = a.popLis[i]['tClass'] ? ' ' + a.popLis[i]['tClass'] : 'middle';//默认文字居中
		aStyle = a.popLis[i]['aStyle'] ? ' ' + a.popLis[i]['aStyle'] : 'style=""';//style=修改样式，例如省略号颜色
		iHtml += '<li><a class="' + tClass + eClass + aClass + '" ' + aStyle + ' doType="' + a.popLis[i]['doType'] + '">'+
					a.popLis[i]['title']+
				 '</a></li>';
	}
	var pHtml = '';
		pHtml = '<div class="inc-popSelect ' + a.popClass + '">'+
					'<ul class="a">'+
						iHtml+
					'</ul>'+
					'<ul class="b">'+
						'<li><a class="middle" doType="cancel">取消</a></li>'+
					'</ul>'+
				'</div>';
	inc.htmlAppend('body',pHtml);
	
	var muiTap = function(e) {
		var doType = this.getAttribute('doType');
		if (inc.mask[a.popClass]) {
			inc.mask[a.popClass].close();//关闭遮罩
			if (doType === 'cancel') return;
			callbackS && callbackS.call(this,{doType:doType});
		}
	};
	mui('.' + a.popClass).on('tap', 'a', muiTap);
	
	//callback 为用户点击蒙版时自动执行的回调；
	inc.mask[a.popClass] = inc.createMask(a.mClass,function(){
		inc.mask[a.popClass] = null;
		mui('.' + a.popClass).off('tap', 'a', muiTap);
		inc.htmlHide('.' + a.popClass,true);
		//bug：特别注意-callbackC函数中不能再使用close(),否则死循环
		callbackC && callbackC(a);
	});
	inc.mask[a.popClass].show();//显示遮罩
	inc.htmlShow('.' + a.popClass);
	return inc.mask[a.popClass];
};
/* *
 * 显示中间加载提示
 * */
inc.showLoadMid = function(isShow,message){
	var pEle = inc.strToEle('div.inc-popLoadMid');
	if (!pEle) {
		var div = document.createElement("div");
			div.innerHTML = '<div class="inc-popLoadMid">'+
								'<div class="a">'+
									'<div class="b"><span class="mui-spinner mui-spinner-white"></span></div>'+
									'<div class="c">正在加载中...</div>'+
								'</div>'+
							'</div>';
		pEle = div.firstElementChild;
		document.body.appendChild(pEle);//document.body.removeChild(toast);
	}
	message = message || '加载中...';
	inc.htmlSet('div.inc-popLoadMid .c',message);
	/**
	 * isShow=布尔值   要改变状态
	 * isShow=null 不改变状态
	 * */
	if (typeof isShow === 'boolean') {
		isShow ? inc.htmlShow(pEle) : inc.htmlHide(pEle);
	}
};
/**
 * 复制，设置剪切板内容
 * http://ask.dcloud.net.cn/question/2034
 * */
inc.copyTextSet = function(setText,callbackS,callbackE) {
	setText = inc.anyToStr(setText).replace(/(\n|\s|&nbsp;|<br>)/ig,' ');
	switch ( plus.os.name ) {
		case "Android":
			var Context = plus.android.importClass("android.content.Context");
			var main = plus.android.runtimeMainActivity();
			var clip = main.getSystemService(Context.CLIPBOARD_SERVICE);
			//设置剪切板文本内容
			plus.android.invoke(clip,"setText",setText);
			//获取剪切板文本内容
			//var value = plus.android.invoke(clip,"getText");
			
			callbackS && callbackS.call({},{ text : setText });
		break;
		case "iOS":
			//获取剪切板
			var UIPasteboard = plus.ios.importClass("UIPasteboard");
			var generalPasteboard = UIPasteboard.generalPasteboard();
			//设置剪切板文本内容
			generalPasteboard.setValueforPasteboardType(setText, "public.utf8-plain-text");
			//获取剪切板文本内容
			//var value = generalPasteboard.valueForPasteboardType("public.utf8-plain-text");
			
			callbackS && callbackS.call({},{ text : setText });
		break;
		default:
			//其它平台
			callbackE && callbackE.call({},{ message : '不是安卓或苹果系统' });
		break;
	}
};
//复制，获取剪切板内容
inc.copyTextGet = function(callbackS,callbackE) {
	var value = '';
	switch ( plus.os.name ) {
		case "Android":
			var Context = plus.android.importClass("android.content.Context");
			var main = plus.android.runtimeMainActivity();
			var clip = main.getSystemService(Context.CLIPBOARD_SERVICE);
			//设置剪切板文本内容
			//plus.android.invoke(clip,"setText",setText);
			//获取剪切板文本内容
			value = plus.android.invoke(clip,"getText");
			value = inc.anyToStr(value).replace(/(\n|\s|&nbsp;|<br>)/ig,' ');
			
			callbackS && callbackS.call({},{ text : value || '' });
		break;
		case "iOS":
			//获取剪切板
			var UIPasteboard = plus.ios.importClass("UIPasteboard");
			var generalPasteboard = UIPasteboard.generalPasteboard();
			//设置剪切板文本内容
			//generalPasteboard.setValueforPasteboardType(setText, "public.utf8-plain-text");
			//获取剪切板文本内容
			value = generalPasteboard.valueForPasteboardType("public.utf8-plain-text");
			value = inc.anyToStr(value).replace(/(\n|\s|&nbsp;|<br>)/ig,' ');
			
			callbackS && callbackS.call({},{ text : value || '' });
		break;
		default:
			//其它平台
			callbackE && callbackE.call({},{ message : '不是安卓或苹果系统' });
		break;
	}
	return value;
};
/* *
 * 强制弹出输入软盘
 * 此功能需要在模块权限中配置Native.js
 * http://ask.dcloud.net.cn/article/513
 * */
inc.softKeyboardOpen = function(callbackS){
	var nativeWebview, imm, InputMethodManager;
	var initNativeObjects = function() {
	        if (mui.os.android) {
	            var main = plus.android.runtimeMainActivity();
	            var Context = plus.android.importClass("android.content.Context");
	       		InputMethodManager = plus.android.importClass("android.view.inputmethod.InputMethodManager");
	        	imm = main.getSystemService(Context.INPUT_METHOD_SERVICE);
		    } else {
		        nativeWebview = plus.webview.currentWebview().nativeInstanceObject();
		    }
		};
	var showSoftInput = function() {
			if (mui.os.android) {
				imm.toggleSoftInput(0, InputMethodManager.SHOW_FORCED);
			} else {
				nativeWebview.plusCallMethod({"setKeyboardDisplayRequiresUserAction":false});
			}
			setTimeout(function() {
				//此处可写具体逻辑设置获取焦点的input
				callbackS && callbackS();
			}, 200);
		};
	initNativeObjects();
	showSoftInput();
};
/**
 * 关闭输入法
 * */
inc.softKeyboardClose = function() {
	var puts = document.querySelectorAll('input');
	for (var i=0;i<puts.length;i++) puts[i].blur();
	var txts = document.querySelectorAll('textarea');
	for (var i=0;i<txts.length;i++) txts[i].blur();
	document.body.focus();
	setTimeout( function () {
		for (var i=0;i<puts.length;i++) puts[i].blur();
		for (var i=0;i<txts.length;i++) txts[i].blur();
		document.body.focus();
	}, 200 );
};
inc.storageItemGet = function(itemId,vType) {
	var vObj = { 'object':{}, 'array':[], 'string':'' },ret=null,fun={};
	fun.eval = function (s,t){
		var r = null;
		if (t === 'object') {
			try{
				r = eval('(' + s + ')');
			}catch(e){ r =  {}; }	
		} else if (t === 'array') {
			try{
				r = eval('(' + s + ')');
			}catch(e){ r = []; }	
		} else if (t === 'string') {
			r = s;	
		}
		return r;
	};
	var s = plus.storage.getItem( itemId );
	if (s === null) {
		s = plus.storage.getItem( itemId );
		if (s === null) {
			ret = vObj[vType];
		} else {
			ret = fun.eval(s,vType);
		}
	} else {
		ret = fun.eval(s,vType);
	}
	return ret;
};
inc.storageItemSet = function(itemId,obj) {
	var val = (obj && typeof obj === 'object') ? JSON.stringify(obj) : inc.anyToStr(obj);
	plus.storage.setItem( itemId, val );
};
inc.storageWinActiveRemove = function(a) {
	var SwinActive = inc.storageItemGet('SwinActive','array');
		SwinActive = inc.remove(SwinActive,a);
	inc.storageItemSet('SwinActive',SwinActive);
	return SwinActive;
};
inc.storageWinActiveAdd = function(a) {
	var SwinActive = inc.storageItemGet('SwinActive','array');
		SwinActive = inc.remove(SwinActive,a);
		SwinActive.push(a)
	inc.storageItemSet('SwinActive',SwinActive);
	return SwinActive;
};
inc.storageWinActiveRemoveAdd = function(a,b) {
	var SwinActive = inc.storageItemGet('SwinActive','array');
		SwinActive = inc.remove(SwinActive,a);
		SwinActive = inc.remove(SwinActive,b);
		SwinActive.push(b);
	inc.storageItemSet('SwinActive',SwinActive);
	return SwinActive;
};
inc.storageDefriendObjGet = function() {
	var SuObj = inc.storageItemGet('SuObj','object');
	var str = inc.anyToStr(SuObj.defriendStr);
	var obj = {},arr = [];
		arr = inc.split(str,',');
		for (var i=0;i<arr.length;i++) {
			obj['aidto_' + arr[i]] = arr[i];
		}
	return obj;
};
//应用商店标记-yingyongbao等
inc.storageChannelSet = function(channel) {
	var obj = {channel:channel}
	inc.storageItemSet("Channel",obj);
	return obj;
};
inc.storageChannelGet = function() {
	return inc.storageItemGet('Channel','object');
};
/**
 * 特别注意：该函数只允许在首页使用
 * 如果要在其他页面使用：请注意正文内容不超过屏幕高度
 * */
inc.storageScreenWHSet = function() {
	var windowWidth  = window.innerWidth; //屏幕宽度, 实际宽度而不是分辨率宽度
	var windowHeight = window.innerHeight;//屏幕高度, 实际高度而不是分辨率高度
	var screenWidth  = plus.screen.resolutionWidth; //实际宽度即逻辑分辨率，而不是设备分辨率
	var screenHeight = plus.screen.resolutionHeight;//实际高度即逻辑分辨率，而不是设备分辨率
	var screenScale  = plus.screen.scale;
	var a,b;
	if (windowWidth >= windowHeight) {
		a = windowWidth;
		b = windowHeight;
		windowWidth  = b;
		windowHeight = a;
	}
	if (screenWidth >= screenHeight) {
		a = screenWidth;
		b = screenHeight;
		screenWidth  = b;
		screenHeight = a;
	}
	var statusHeight = plus.navigator.getStatusbarHeight();//状态栏高度
	var screenWH     = {
		width  : inc.anyToFlo(  screenWidth || windowWidth  , 0, true ),
		height : inc.anyToFlo( (screenHeight - statusHeight) || windowHeight , 0, true ),
		status : inc.anyToFlo(  statusHeight , 0, true ),
		windowWidth  : windowWidth,
		windowHeight : windowHeight,
		screenWidth  : screenWidth,
		screenHeight : screenHeight,
		screenScale  : screenScale,
		statusHeight : statusHeight
	};
//	screenWH     = {
//		width  : 768,
//		height : 1004,
//		status : 20,
//		windowWidth  : 768,
//		windowHeight : 1004,
//		screenWidth  : 768,
//		screenHeight : 1024,
//		screenScale  : 2,
//		statusHeight : 20
//	};//用于测试苹果平板-iPad min 9.70寸分辨率   768*1024*2=1536*2048
//	screenWH     = {
//		width  : 1024,
//		height : 1316,
//		status : 20,
//		windowWidth  : 1024,
//		windowHeight : 1316,
//		screenWidth  : 1024,
//		screenHeight : 1366,
//		screenScale  : 2,
//		statusHeight : 20
//	};//用于测试苹果平板-iPad pro 12.9寸分辨率 1024*1366*2=2048*2732
	inc.storageItemSet("ScreenWH",screenWH);
	return screenWH;
}
/**
 * * bug：注意当旋转全屏后，宽度和高度混乱***所以优先使用index.html存储在本地的ScreenToWebviewWH
 * * plus.screen.resolutionWidth 不能使用 有bug:可能不是实际宽高而是分辨率宽高
 * */
inc.storageScreenWHGet = function(){
	var o = inc.storageItemGet('ScreenWH','object');
	if (o.width && o.height) {
		o.width  = inc.anyToInt( o.width  );
		o.height = inc.anyToInt( o.height );
		o.status = inc.anyToInt( o.status );
	} else {
		o = inc.storageScreenWHSet();
	}
	return o;
};
/*
 * 是否使用大一号字体，字体以iOS为准
 * iPad min 9.70寸分辨率   768*1024*2=1536*2048
 * iPad pro 12.9寸分辨率 1024*1366*2=2048*2732
 * */
inc.isPadWidthMax = function() {
	var WH = inc.storageScreenWHGet();
	return WH.width >= 800 ? true : false;
};
/*
 * 是否使用大一号字体，字体以iOS为准
 * iphone5s分别率 320*568*2=640*1136
 * iphone6s分别率 375*677*2=750*1334
 * iphone7s分别率 375*677*2=750*1334
 * iPad min 9.70寸分辨率   768*1024*2=1536*2048
 * iPad pro 12.9寸分辨率 1024*1366*2=2048*2732
 * */
inc.isFontSizeBig = function() {
	if (inc.isIOS()) {
		var WH = inc.storageScreenWHGet();
		return (WH.screenWidth * WH.screenScale >= 750) ? true : false;
	} else {
		return false;
	}
};
/**
 * readyState 属性
 * 0 请求未初始化（在调用 open() 之前）。初始化状态 XMLHttpRequest 对象已创建或已被 abort() 方法重置。
 * 1 请求已提出（调用 send() 之前）
 * 2 请求已发送（这里通常可以从响应得到内容头部）
 * 3 请求处理中（响应中通常有部分数据可用，但是服务器还没有完成响应）
 * 4 请求已完成（可以访问服务器响应并使用它） 
 * */
inc.ajax = {};
//从服务器返回的错误提示信息
inc.ajax.errorLogin = function(retStr) {
	if (retStr === 'MLoginErrorEmptyM'  || retStr === 'MLoginErrorNoUserM' ||
		retStr === 'MLoginErrorNoCodeM' || retStr === 'MLoginErrorForbidM') {
		return true;
	} else {
		return false;
	}
}
//从服务器返回的错误提示信息
inc.ajax.errorFirst = function(retStr,isOpen) {
	var retBool = inc.ajax.errorLogin(retStr);
	if (retBool) {
		inc.showLoadMid(false);
		inc.storageItemSet('SuObj',{});//重置用户登录信息
		if (plus.webview.currentWebview().id !== 'index-home.html') {
			inc.winFire('index-home.html','homeReload',{isFirst:false});
		}
		
		isOpen = typeof isOpen === 'boolean' ? isOpen : true;
		isOpen && inc.winOpen('id-login-third.html');
	}
	return retBool;
};
inc.ajax.errorFinal = function(retStr) {
	if (typeof retStr !== 'undefined') inc.showAlert( "错误提示：" + retStr );
};
inc.ajax.isShowXhrEvalErr = true;//临时设置返回数据错误可见
inc.ajax.xhrToEval = function(xhrRet,isShowXhrEvalErr) {
	var retObj = {};
	xhrRet = xhrRet || '{}';
	isShowXhrEvalErr = typeof isShowXhrEvalErr === 'boolean' ? isShowXhrEvalErr : inc.ajax.isShowXhrEvalErr;
	try{
		var r = eval('(' + xhrRet + ')');
		if (typeof r === 'object' && r) {
			if (r.evalJSOnly) {
				eval(r.evalJSOnly);
			} else {
				if (r.evalJSAnd) eval(r.evalJSAnd);
				retObj = r;
			}
		}
	} catch(e) {
		isShowXhrEvalErr && inc.showAlert(xhrRet);
	}
	return retObj;
};
inc.ajax.xhr = function() {
	if (typeof XMLHttpRequest !== 'undefined') return new XMLHttpRequest();
	var versions = ['MSXML2.XmlHttp.6.0','MSXML2.XmlHttp.5.0','MSXML2.XmlHttp.4.0',
					'MSXML2.XmlHttp.3.0','MSXML2.XmlHttp.2.0','Microsoft.XmlHttp'];
	var xhr;
	for (var i=0;i<versions.length; i++) {
		try {
			xhr = new ActiveXObject(versions[i]);
			break;
		} catch (e) {}
	}
	return xhr;
};
inc.ajax.query = function(data) {
	data = data || {};
	var dArr = [];
	for (var key in data) {
		dArr.push(encodeURIComponent(key) + '=' + encodeURIComponent(data[key]));
	}
	return inc.join(dArr,'&');
};
inc.ajax.setTimeout = function(callbackS,timeout) {
	var t = setTimeout(function(){
			t && clearTimeout(t);
			callbackS && callbackS();
		},timeout);
	return t;
};
inc.ajax.abort = function(xhr) {
	//xhr=[object XMLHttpRequest]
	if (xhr && typeof xhr === 'object') {
		xhr.isOut = true;
		xhr.abort && xhr.abort();
	} else if (xhr && typeof xhr === 'string' && xhr === 'all') {
		for (var i=0;i<inc.xhrs.length;i++) {
			xhr = inc.xhrs[i];
			if (xhr && typeof xhr === 'object') {
				if (!xhr.isOut) {
					 xhr.isOut = true;
					 xhr.abort && xhr.abort();
				}
			}
		}
		inc.xhrs = [];
	}
};
inc.ajax.send = function(a,callbackS,callbackE) {
	a.xUrl    = a.xUrl;//请求地址
	a.data    = a.data || {};
	a.method  = a.method || 'POST';//POST或GET发送数据
	a.async   = typeof a.async === 'boolean' ? a.async : true; //true=异步，false=同步
	a.timeout = (a.timeout || 10) * 1000; //超时时间，秒
	a.xhrType = a.xhrType || 'mui'; //xhrType=window,mui,plus
	a.crossDomain = a.crossDomain;//默认值undefined //true=强制使用5+跨域  //WKWebview内核下必须强制5+跨域
	
	var fun = {};
		fun.callbackS = function(retData){
			if (typeof callbackS === 'object' && callbackS.callbackS) {
				callbackS.callbackS.call(a,{backRArgs:callbackS.backRArgs,retData:retData});
			} else {
				callbackS && callbackS.call(a,{retData:retData});
			}
		};
		fun.callbackE = function(message,orgErr){
			if (typeof callbackE === 'object' && callbackE.callbackE) {
				callbackE.callbackE.call(a,{backRArgs:callbackE.backRArgs,message:message,orgErr:orgErr});
			} else {
				callbackE && callbackE.call(a,{message:message,orgErr:orgErr});
			}
		};
	//普通用户登录
	a.SuObj = inc.storageItemGet('SuObj','object');
	if (a.SuObj.aidme && a.SuObj.saltB && a.SuObj.codeB) {
		a.data.aidme = a.SuObj.aidme;
		a.data.saltB = a.SuObj.saltB;
		a.data.codeB = a.SuObj.codeB;
	}
	//管理员登录
	a.SaObj = inc.storageItemGet('SaObj','object');
	if (a.SaObj.adminId && a.SaObj.adminSa && a.SaObj.adminCo) {
		a.data.adminId = a.SaObj.adminId;
		a.data.adminSa = a.SaObj.adminSa;
		a.data.adminCo = a.SaObj.adminCo;
	}
	//用户端标记
	if (!a.data.ridme && !a.data.rsign) {
		a.SrObj = inc.storageItemGet('SrObj','object');
		if (a.SrObj.ridme && a.SrObj.rsign) {
			a.data.ridme = a.SrObj.ridme;
			a.data.rsign = a.SrObj.rsign;
		}
	}
	//链接页面
	a.data.pageId    = plus.webview.currentWebview().id;
	//应用商店
	a.data.channel   = inc.storageChannelGet().channel;
	//应用程序相关信息
	a.data.appid     = plus.runtime.appid; //当前应用的APPID
	a.data.version   = plus.runtime.version; //应用程序版本
	a.data.deVendor  = plus.device.vendor; //设备的生产厂商
	a.data.deModel   = plus.device.model; //设备的型号
	a.data.osName    = plus.os.name; //系统的名称
	a.data.osVersion = plus.os.version; //系统的版本
	
	var settings = {}, o = plus.webview.currentWebview().o || {};
	if (typeof a.crossDomain === 'boolean' || typeof o.crossDomain === 'boolean') {
		a.xhrType = 'mui'; //强制跨域时必须使用mui
		settings.crossDomain = typeof a.crossDomain === 'boolean' ? a.crossDomain : o.crossDomain;
	}
	if (a.xhrType === 'mui') {
		settings.async    = a.async; //true=异步，false=同步
		settings.type     = a.method; //HTTP请求类型//GET,POST
		settings.dataType = 'text'; //"json": 返回JSON数据 //"text": 返回纯文本字符串
		settings.timeout  = a.timeout;//超时时间设置为15秒
		settings.data     = a.data; //发送到服务器的数据，可以是json对象或字符串
		settings.success  = function(data,textStatus,xhr) {
			fun.callbackS(data);
			inc.ajax.abort(xhr);
		};
		settings.error    = function(xhr,type,err) {
			inc.networkinfo() === "none" && inc.showToast({isHtml:true,message:'貌似没有网络'});
			//type：错误描述，可取值："timeout", "error", "abort", "parsererror"、"null"
			//err：可捕获的异常对象，Not Found 该链接不存在
			//inc.isDevelop && console.log('错误描述：' + type + ' - ' + '错误异常：' + err);
			if (xhr.isOut) {
				return;
			} else {
				inc.ajax.abort(xhr);
				//继续加载//如果retry=0 在无限次
				setTimeout( function () {
					inc.ajax.send(a,callbackS,callbackE);
				}, 2500 );
			}
		};
		var xhr = mui.ajax(a.xUrl,settings);
		if (xhr && typeof xhr === 'object') {
			xhr.isOut = false;
			inc.xhrs.push(xhr);
		}
	} else if (a.xhrType === 'window') {
		var xUrl,xSend,xQuery;
		var xQuery = inc.ajax.query(a.data);
		if (a.method === 'POST') {
			xUrl  = a.xUrl;
			xSend = xQuery;
		} else {
			xUrl  = xQuery ? (a.xUrl + '?' + xQuery) : a.xUrl;
			xSend = null;
		}
		var xhr = inc.ajax.xhr();
			xhr.isOut = false;
			inc.xhrs.push(xhr);
		var t   = inc.ajax.setTimeout(function(){
					inc.ajax.abort(xhr);
					inc.ajax.send(a,callbackS,callbackE);
				},a.timeout);
		xhr.open(a.method, xUrl, a.async);
		if (a.method === 'POST') {
			xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		}
		xhr.onreadystatechange = function(s) {
			inc.networkinfo() === "none" && inc.showToast({isHtml:true,message:'貌似没有网络'});
			if (xhr.isOut) return;
			t && clearTimeout(t);
			if (xhr.readyState == 4) {
				if (xhr.status == 200) {
					fun.callbackS(xhr.responseText);
					inc.ajax.abort(xhr);
				} else {
					//inc.isDevelop && console.log('a=' + inc.printObj(a) );
					//inc.isDevelop && console.log(xhr.readyState + '-' + xhr.status );
					if (xhr.isOut) {
						return;
					} else {
						inc.ajax.abort(xhr);
						//继续加载//如果retry=0 在无限次
						setTimeout( function () {
							inc.ajax.send(a,callbackS,callbackE);
						}, 2500 );
					}
				}
			}
		};
		xhr.send(xSend);
	}
};
/**
 * 监听页面滚动
 * */
inc.windowScroll = function(a,callbackS,callbackE) {
	a = (a && typeof a === 'object') ? a : {};
	
	if (!a.eleId || a.eleId === window) {
		var clientHeight = document.documentElement.clientHeight;//窗口高度
		var scrollHeight = Math.max(document.documentElement.scrollHeight,document.body.scrollHeight);//内容总高度
		var scrollTop    = document.body.scrollTop; //内容顶部滚过的高度	
	} else {
		var ele = inc.strToEle(a.eleId);
		if (ele) {
			var clientHeight = ele.offsetHeight;//窗口高度
			var scrollHeight = ele.scrollHeight;//内容总高度
			var scrollTop    = ele.scrollTop; //内容顶部滚过的高度
		} else {
			return false;
		}
	}
	//当 scrollHeight - scrollTop - clientHeight === 0 是表示滚动到底部了
	var scrollBottom = scrollHeight - scrollTop - clientHeight;
	var o = {
			clientHeight : clientHeight,
			scrollHeight : scrollHeight,
			scrollTop    : scrollTop,
			scrollBottom : scrollBottom
		};
		o.minHeight = a.minHeight || 0;
	
	if (a.doType === 'scrollBottom') {
		if (scrollBottom <= o.minHeight) {
			callbackS && callbackS.call(o,o);
			return true;
		} else {
			callbackE && callbackE.call(o,o);
			return false;
		}
	} else if (a.doType === 'scrollTop') {
		if (scrollTop <= o.minHeight) {
			callbackS && callbackS.call(o,o);
			return true;
		} else {
			callbackE && callbackE.call(o,o);
			return false;
		}
	} else {
		callbackS && callbackS.call(o,o);
		return false;
	}
};
/**
 * 内容滚动至顶部
 * */
inc.scrollToTop = function(a) {
	a = (a && typeof a === 'object') ? a : {};
	if (!a.eleId || a.eleId === window) {
		if (window.scroll || window.scrollTo) {
			window.scroll   && window.scroll(0,0);
			window.scrollTo && window.scrollTo(0,0);
			//document.body.scrollTop = 0;
		} else {
			document.body.scrollTop = 0;
		}
	} else {
		var ele = inc.strToEle(a.eleId);
		if (ele) ele.scrollTop = 0;
	}
};
/**
 * 内容滚动至固定高度
 * */
inc.scrollToFixed = function(a) {
	a = (a && typeof a === 'object') ? a : {};
	a.scrollTop = a.scrollTop || 0;
	if (!a.eleId || a.eleId === window) {
		if (window.scroll || window.scrollTo) {
			window.scroll   && window.scroll(0,a.scrollTop);
			window.scrollTo && window.scrollTo(0,a.scrollTop);
			//document.body.scrollTop = a.scrollTop;
		} else {
			document.body.scrollTop = a.scrollTop;
		}
	} else {
		var ele = inc.strToEle(a.eleId);
		if (ele) ele.scrollTop = a.scrollTop;
	}
};
//顶部右侧弹出菜单栏
document.addEventListener('closeOpenerWaiting',function(e) {
	window.plus && plus.nativeUI.closeWaiting();
},false);
inc.closeOpenerWaiting = function(winIdOpener) {
	plus.nativeUI.closeWaiting();
	if (winIdOpener) {
		inc.winFire(winIdOpener,'closeOpenerWaiting');
		var win = inc.winGet(winIdOpener);
		win && win.o && win.o.winIdOpener && inc.winFire(win.o.winIdOpener,'closeOpenerWaiting');
	}
};
document.addEventListener('hideAndShow',function(e) {
	var winIdH = e.detail.winIdH;
	var winIdS = e.detail.winIdS;
	if (winIdH === 'index-same.html'    || winIdH === 'index-sale.html' || 
		winIdH === 'index-article.html' || winIdH === 'index-home.html') {
		inc.winHide(plus.runtime.appid);
		inc.winHide(winIdH);
	} else {
		inc.winHide(winIdH);
	}
	inc.winShow(winIdS);
},false);
//document.addEventListener('showAndHide',function(e) {
//	inc.winShow(e.detail.winIdS);
//	inc.winHide(e.detail.winIdH);
//},false);
//document.addEventListener('closeAndShow',function(e) {
//	inc.winClose(e.detail.winIdC);
//	inc.winShow( e.detail.winIdS);
//},false);
//document.addEventListener('showAndClose',function(e) {
//	inc.winShow( e.detail.winIdS);
//	inc.winClose(e.detail.winIdC);
//},false);
//仅用于创建子窗口
inc.winCreate = function(a,extras,styles,callbackS) {
	inc.softKeyboardClose();//关闭输入法
	
	a = (a && typeof a === 'object') ? a : {winId : a};
	a.winUi = a.winUi || a.winId;//空、网络地址、本地地址
	if (!a.winId) {
		inc.showToast('a.winId不能为空值');
		return;
	}
	//关闭已打开的窗口,避免创建重复窗口
	inc.winClose(a.winId,function(){
		extras = extras || {};
		extras.winIdOpener = plus.webview.currentWebview().id;
		if (!extras.winIdParent) {
			inc.showToast('inc.winCreate-仅用于创建子窗口，所以必须指定-父窗口Id-winIdParent');
			return;
		}
		if (a.winId.indexOf('child') === -1) {
			inc.showToast('inc.winCreate=仅用于创建子窗口，winId中必须包含单词-child-' + a.winId);
			return;
		}
		
		styles = styles || {};
		//iOS-窗口内容停止滑动的减速度 0-1，默认值为0.989
		if (!styles.decelerationRate) styles.decelerationRate = 0.999;
		/**
		 * 特别注意：子页面不可以设置 styles.render = "always" 否则bug：页面莫名其妙消失
		 * */
		//"none"：垂直和水平滚动条都不显示；"vertical"：仅显示垂直滚动条；
		if (!styles.scrollIndicator) styles.scrollIndicator = "none";
		
		var tWin = plus.webview.create(a.winUi,a.winId,styles,{o:extras});
			callbackS && callbackS.call({},{tWin:tWin});
	});
};
inc.winOpen = function(a,extras,styles,callbackS) {
	inc.softKeyboardClose();//关闭输入法
	
	a = (a && typeof a === 'object') ? a : {winId : a};
	a.winUi = a.winUi || a.winId;//空、网络地址、本地地址
	if (!a.winId) {
		inc.showToast('a.winId-不能为空值');
		return;
	}
	if (a.winId.indexOf('child') !== -1) {
		inc.showToast('inc.winOpen-仅用于创建父窗口-winId-' + a.winId);
		return;
	}
	//关闭已打开的窗口,避免创建重复窗口
	inc.winClose(a.winId,function(){
		extras = extras || {};
		extras.winIdOpener = plus.webview.currentWebview().id;
		extras.winIdParent = a.winId;//父窗口就是自己
		
		styles = styles || {};
		
		//窗口的层叠次序。在iOS无效中，因为即使层叠次序低的窗口只要show就会直接显示出来。
		if (!styles.zindex) styles.zindex = 100;
		
		//iOS-窗口内容停止滑动的减速度 0-1，默认值为0.989
		if (!styles.decelerationRate) styles.decelerationRate = 0.999;
		
		//"onscreen"：Webview窗口在屏幕区可见时渲染，不可见时不进行渲染，此时能减少内存使用量；
		//"always"：窗口在任何时候都渲染，在内存较大的设备上使用，被遮挡的窗口在此中模式下显示的时候会有更流畅的效果
		if (!styles.render) styles.render = "always";
		
		//"none"：垂直和水平滚动条都不显示；"vertical"：仅显示垂直滚动条；
		if (!styles.scrollIndicator) styles.scrollIndicator = "none";
		
		//可取值"none"：无侧滑返回功能；"close"：侧滑返回关闭Webview窗口；"hide"：侧滑返回隐藏webview窗口。 仅iOS平台支持。
		if (inc.isIOS()) {
			if (!styles.popGesture) styles.popGesture = "close";
		} else {
			styles.popGesture = "none";
		}
		
		/***自定义styles属性-s***********************************************/
		/***自定义styles属性-e***********************************************/
		
		a.waits = a.waits || {};
		a.waits.isShow  = typeof a.waits.isShow === 'boolean' ? a.waits.isShow : true;
		a.waits.title   = a.waits.title || '';
		a.waits.options = a.waits.options || null;
		a.waits.isShow && inc.showWaiting(a.waits.title,a.waits.options);
		
		var SwinActive = inc.storageWinActiveAdd(a.winId);
		//inc.isDevelop && console.log( 'inc.winOpen-SwinActive-' + inc.printObj(SwinActive) );
		
		var tWin = plus.webview.create(a.winUi,a.winId,styles,{o:extras});
			tWin.hide();
			callbackS && callbackS.call({},{tWin:tWin});
	});
};
inc.winGet = function(winId){
	var oWin = null;
	if (winId) {
		oWin = typeof winId === 'object' ? winId : plus.webview.getWebviewById(winId);
	} else {
		oWin = plus.webview.currentWebview();
	}
	return oWin;
};
inc.winStyleSet = function(winId,styles) {
	var sWin = inc.winGet(winId);
	if (sWin && styles) sWin.setStyle(styles);
};
inc.winStyleGet = function(winId) {
	var sWin = inc.winGet(winId);
	return sWin ? sWin.getStyle() : {};
};
//触发窗口事件
inc.winFire = function(winId,fireName,extras) {
	var oWin = inc.winGet(winId);
	oWin && fireName && mui.fire(oWin,fireName,extras || {});
};
//强制刷新窗口页面
inc.winReload = function(winId) {
	inc.softKeyboardClose();//关闭输入法
	var oWin = inc.winGet(winId);
	if (oWin) oWin.reload(true);
};
//显示当前窗口或指定窗口
inc.winShow = function(winId) {
	inc.softKeyboardClose();//关闭输入法
	var oWin = inc.winGet(winId);
	if (oWin) {
		//index.html-的id-HBuilder
		if (oWin.id !== plus.runtime.appid) {
			//如果是父窗口则存储
			if (oWin.id === oWin.o.winIdParent) {
				var SwinActive = inc.storageWinActiveAdd(oWin.id);
				//inc.isDevelop && console.log( 'inc.winShow-SwinActive-' + inc.printObj(SwinActive) );
			}
		}
		oWin.show('none',0);
	}
};
//隐藏当前窗口或指定窗口
inc.winHide = function(winId) {
	inc.softKeyboardClose();//关闭输入法
	var oWin = inc.winGet(winId);
	if (oWin) oWin.hide('none',0);
};
//关闭当前窗口或指定窗口//避免创建重复窗口
inc.winClose = function(winId,callbackS) {
	inc.softKeyboardClose();//关闭输入法
	var oWin = inc.winGet(winId);
	var fun = {};
		fun.setTimeout = function() {
			setTimeout(function(){
				var tWin = inc.winGet(winId);
				tWin ? fun.setTimeout() : callbackS();
			},10);
		};
	if (oWin) {
		//index.html-的id-HBuilder
		if (oWin.id !== plus.runtime.appid) {
			//如果是父窗口则存储
			if (oWin.id === oWin.o.winIdParent) {
				var SwinActive = inc.storageWinActiveRemove(oWin.id);
				//inc.isDevelop && console.log( 'inc.winClose-SwinActive-' + inc.printObj(SwinActive) );
			}
		}
		oWin.close('none',0);
		if (callbackS) {
			var tWin = inc.winGet(winId);
			tWin ? fun.setTimeout() : callbackS();
		}
	} else {
		callbackS && callbackS();
	}
};
/**
 * 处理返回事件
 * isClose=true 关闭页面，false 隐藏页面
 * */
inc.winBack = function(a,callbackS) {
	inc.softKeyboardClose();//关闭输入法
	a = (a && typeof a === 'object') ? a : {};
	a.winIdOpener = null;
	a.winIdParent = a.winIdParent || inc.winIdParent(null);//父窗口
	a.isClose     = typeof a.isClose === 'boolean' ? a.isClose : true;
	
	if (inc.isAndroid()) {
		var SwinActive = inc.storageItemGet('SwinActive','array');
		for (var i=0;i<SwinActive.length;i++) {
			if (a.winIdParent === SwinActive[i]) {
				a.winIdOpener  =  SwinActive[i-1];
				break;
			}
		}
		a.winIdOpener = a.winIdOpener || SwinActive[SwinActive.length-2];
		SwinActive = inc.storageWinActiveRemove(a.winIdParent);
		//inc.isDevelop && console.log( 'inc.winBack-SwinActive-' + inc.printObj(SwinActive) );
		
		if (a.winIdOpener === 'index-same.html'    || a.winIdOpener === 'index-sale.html' ||
			a.winIdOpener === 'index-article.html' || a.winIdOpener === 'index-home.html') {
			inc.winShow(plus.runtime.appid);
			inc.winShow(a.winIdOpener);
		}

		if (a.isClose) inc.winStyleSet(a.winIdParent,{render:'onscreen'});
		inc.winHide(a.winIdParent);
		inc.winShow(a.winIdOpener);
		if (a.isClose) inc.winClose(a.winIdParent);
		callbackS && callbackS();
	} else {
		a.isClose ? inc.winClose(a.winIdParent) : inc.winHide(a.winIdParent);
		callbackS && callbackS();
	}
};
/**
 * 获取父窗口id
 * 特别注意：子窗口id必须含有child字符串，且设置了winIdParent
 * 同一页面，所有子窗口均所属于同一父窗口，不允许子窗口拥有子窗口
 * */
inc.winIdParent = function(winId) {
	var win = inc.winGet(winId);
	if (win && win.o && win.o.winIdParent) {
		return win.o.winIdParent;
	} else {
		inc.showToast( (win ? win.id : '窗口不存在') + '-该窗口未设置父窗口-winIdParent');
		return 'notExist.html';
	}
};
/**
 * 获取父窗口的创建者的父窗口
 * winId=null 或 父窗口id 或 子窗口id
 * */
inc.winIdOpener = function(winId) {
	if (winId === 'same.html') {
		//必须使用pub，因为 same.html 页面不是实时创建的，否则只能获取到旧信息
		if (pub && pub.o && pub.o.winIdFire) {
			return pub.o.winIdFire;
		} else {
			inc.showToast('pub.o.winIdFire-不存在');
			return 'notExist.html';
		}
	}
	var win = inc.winGet( inc.winIdParent(winId) );
	return inc.winIdParent( win.o.winIdOpener );
};
/**
 * 隐藏创建窗口
 * isOpener=true 表示 winId 就是创建者并且创建者是父窗口
 * */
inc.winIdOpenerHide = function(winId) {
	if (inc.isAndroid()) {
		var winIdOpener = inc.winIdOpener(winId);
		var winIdParent = inc.winIdParent(null);
		inc.winFire(winIdOpener,'hideAndShow',{winIdH:winIdOpener, winIdS:winIdParent,});
	} else {
		var winIdParent = inc.winIdParent(null);
		inc.winShow(winIdParent);
	}
};
//退出应用
inc.appQuitFirstTime = null;
inc.appQuit = function() {
	 //首页返回键处理//处理逻辑：1秒内，连续两次按返回键，则退出应用；
	if (!inc.appQuitFirstTime) {
		inc.showToast('再按一次退出');
		inc.appQuitFirstTime = (new Date()).getTime();
		setTimeout(function() {
			inc.appQuitFirstTime = null;
		}, 1000);
	} else {
		if ((new Date()).getTime() - inc.appQuitFirstTime < 1000) {
			plus.runtime.quit();
		}
	}
};
/**
 * *  *
 * dirName
 * *  * dirName为空时用tempOther
 * *  * dirName=sound、tempOther、avatarSmall、avatarMiddle
 * *  * imid为null时用本地时间
 * *  * ext只能为jpg或amr//录音格式 Android 默认 amr / iOS 默认 wav //如果想通用，用amr格式
 * *  * 
 * fileFull=平台绝对路径
 * *  * 该绝对路径符合各平台文件路径格式，通常用于Native.JS调用系统原生文件操作API，也可以在前面添加“file://”后在html页面中直接使用
 * *  * Android平台转换后的路径为-“/storage/sdcard/Android/data/io.dcloud.HBuilder/.HBuilder/apps/HBuilder/doc/a.jpg”
 * *  * 在iOS平台转换后的路径为-“/var/mobile/Containers/Data/Application/757966CF-345C-4348-B07F-EEF83CF9A369/
 * *  * Library/Pandora/apps/HBuilder/doc/a.png”
 * *  * 
 * fileRel=相对路径，直接用于html中
 * *  * a.jpg***dirName/q.jpg***../doc/dirName/q.jpg***file:///storage/.../a.jpg
 * *  * 
 * filePath='file://' + fileFull。文件完整的相对路径且包含file://，直接用于html中。file:///storage/.../a.jpg
 * *  * 
 * fileDoc=HBuilder专用相对路径，以_doc开头。 _doc/dirName/q.jpg***-/storage/.../a.jpg
 * *  *
 * fileImui=文件网络地址 https://i.765cn.com/03/02/01/010203.jpg
 * *  *
 * */
//特别注明：文件必须是存储在/doc/目录中 //imid 或是文件名
inc.fileCreateDir  = function(dirName,imid,ext) {
	dirName = dirName || "tempOther";
	imid = imid ? imid : (new Date()).getTime();
	ext  = ext || 'jpg';
	return dirName + "/" + imid + "." + ext;
};
//特别注明：文件必须是存储在/doc/目录中
inc.fileCreateRel  = function(dirName,imid,ext) {
	return "../doc/" + inc.fileCreateDir(dirName,imid,ext);
};
//特别注明：文件必须是存储在/doc/目录中
inc.fileCreateDoc  = function(dirName,imid,ext) {
	return "_doc/"   + inc.fileCreateDir(dirName,imid,ext);
};
//特别注明：文件必须是存储在/doc/目录中
inc.fileCreateFull = function(dirName,imid,ext) {
	var fileDoc  = inc.fileCreateDoc(dirName,imid,ext);
	var fileFull = inc.fileAnyToFull(fileDoc);
	return fileFull;
};
//特别注明：文件必须是存储在/doc/目录中
inc.fileCreatePath = function(dirName,imid,ext) {
	var fileFull = inc.fileCreateFull(dirName,imid,ext);
	return fileFull ? 'file://' + fileFull : '';
};
/**
 * plus.io.convertLocalFileSystemURL-将本地URL路径转换成平台绝对路径，可在前面添加“file://”后在html页面中直接使用
 * */
inc.fileAnyToFull = function(any) {
	var fileFull = '';
	if (any && typeof any === 'string' && any.indexOf('/') !== -1) {
		fileFull = plus.io.convertLocalFileSystemURL(any) || '';
	}
	return fileFull;
};
/**
 * 这里返回的绝对路径可以直接用于html页面，file://
 * */
inc.fileAnyToPath = function(any){
	var fileFull = inc.fileAnyToFull(any);
	return fileFull ? 'file://' + fileFull : '';
};
/**
 * plus.io.convertAbsoluteFileSystem=将绝对路径转换成相对路径
 * 特别注意：这里返回的相对路径一律以_doc 或 _www 开头
 * */
inc.fileAnyToDoc = function(any) {
	var fileDoc = '';
	if (any && typeof any === 'string' && any.indexOf('/') !== -1) {
		var fileFull = inc.fileAnyToFull(any);
		if (fileFull) fileDoc = plus.io.convertAbsoluteFileSystem(fileFull) || '';
	}
	return fileDoc;
};
/**
 * 这里返回的相对路径可以直接用于html页面
 * */
inc.fileAnyToRel = function(any) {
	var fileDoc = inc.fileAnyToDoc(any);
	var fileRel = '';
	if (fileDoc.substr(0,5) === '_doc/') {
		fileRel = '../doc/' + fileDoc.substr(5);
	} else if (fileDoc.substr(0,5) === '_www/') {
		fileRel = fileDoc.substr(5);
	}
	return fileRel;
};
inc.fileAnyToImid = function(any){
	any = inc.anyToStr(any);
	var imid = '';
	if (any.indexOf('.') === -1) {
		imid = any;
	} else {
		var iArr = inc.split(any,'/');
		var iLen = iArr.length;
		if (iLen >= 1) {
			var sArr = inc.split(iArr[iLen - 1],'.');
			if (sArr.length >= 2) {
				imid = sArr[0];
			}
		}
	}
	return imid;
};
inc.fileAnyToImui = function(any,ext){
	any = inc.anyToStr(any);
	ext = ext || 'jpg';
	var imui  = '';
	var imid = inc.fileAnyToImid(any);
	if (imid) {
		var zArr = ['0','00','000','0000','00000','000000'];
		var iLen = imid.length;
		var dir  = iLen <= 5 ? zArr[6 - iLen - 1] + imid : imid.substr(-6,6);;
		var df   = dir.substr(-2,2);//第一层目录
		var ds   = dir.substr(-4,2);//第二层目录
		var dt   = dir.substr(-6,2);//第三层目录
		var midd = df + "/" + ds + "/" + dt + "/";
		if (ext === 'jpg' || ext === 'png' || ext === 'gif') {
			imui = 'https://i.765cn.com/' + midd + imid + "." + ext;
		}
	}
	return imui;
};
/*
 * toWidth 根据宽度按比例缩放
 * */
inc.fileImgWidthToWH = function(orgWidth,orgHeight,toWidth) {
	orgWidth  = inc.anyToInt(orgWidth);
	orgHeight = inc.anyToInt(orgHeight);
	toWidth   = inc.anyToInt(toWidth);
	var width = 0, height = 0;
	if (orgWidth > 0 && orgHeight > 0) {
		width  = toWidth;
		height = Math.ceil( (width * orgHeight) / orgWidth );
	}
	return {width:width,height:height};
};
/*
 * toHeight 根据高度按比例缩放
 * */
inc.fileImgHeightToWH = function(orgWidth,orgHeight,toHeight) {
	orgWidth  = inc.anyToInt(orgWidth);
	orgHeight = inc.anyToInt(orgHeight);
	toHeight  = inc.anyToInt(toHeight);
	var width = 0, height = 0;
	if (orgWidth > 0 && orgHeight > 0) {
		height = toHeight;
		width  = Math.ceil( (height * orgWidth) / orgHeight );
	}
	return {width:width,height:height};
};
/*
 * toMaxSide根据最长边按比例缩放，小于则不缩放
 * */
inc.fileImgMaxSideToWH = function(orgWidth,orgHeight,toMaxSide) {
	orgWidth  = inc.anyToInt(orgWidth);
	orgHeight = inc.anyToInt(orgHeight);
	toMaxSide = inc.anyToInt(toMaxSide);
	var width = 0, height = 0;
	if (orgWidth > 0 && orgHeight > 0 && toMaxSide > 0) {
		var orgMaxSide = Math.max(orgWidth, orgHeight);
		if (orgMaxSide <= toMaxSide) {
			width  = orgWidth;
			height = orgHeight;
		}else{
			if (orgWidth > orgHeight) {
				width  = toMaxSide;
				height = Math.ceil( (width * orgHeight) / orgWidth );
			}else{
				height = toMaxSide;
				width  = Math.ceil( (height * orgWidth) / orgHeight );
			}
		}	
	}
	return {width:width,height:height};
};
/**
 * 拍照或从相册中选择图片
 * 自定义弹出选择提示 popSelect
 * 特别注意：a=数组-必须指定title[{dotype:dotype,title:title}] 或 null 
 * */
inc.popSelectCameraGallery = function(a,callbackS,callbackE) {
	if (!inc.isArray(a)) a = [];
	var popLis = [];
	if (a.length >= 1) {
		for (var i=0;a<a.length;i++) {
			popLis.push({doType : a.doType, title : a.title});
		}
	} else {
		//gallerys非默认
		popLis.push({doType:'camera',  title:'拍照'});
		popLis.push({doType:'gallery', title:'从相册中选择'});
	}
	inc.showPopSelect({
		popLis   : popLis,
		popClass : 'popSelectCG'
	},function(s) {
		//inc.isDevelop && console.log( 's.doType-' + s.doType );
		inc.fileImgFromCameraGallery(s.doType,function(s){
			//inc.isDevelop && console.log( '从相册中返回图片路径-s-' + inc.printObj(s) );
			//拷贝至本地
			inc.fileCopyTo({
				fileDoc : s.files[0], //相册或拍照返回的文件路径一律是file:///
				saveDoc : inc.fileCreateDoc(),
			},function(s){
				//inc.isDevelop && console.log( '将图片拷贝到指定位置成功-s-' + inc.printObj(s) );
				callbackS && callbackS.call({},{fileDoc:s.fileDoc});
			},function(e){
				//inc.isDevelop && console.log( '将图片拷贝到指定位置失败-e-' + inc.printObj(e) );
				inc.showAlert('将图片拷贝到指定位置失败');
			});
		},function(e){
			//inc.isDevelop && console.log( '拍照或获取相册图片失败-e-' + inc.printObj(e) );
			//inc.showAlert('拍照或获取相册图片失败');
		});	
	});
};
/**
 * 拍照或从相册中选择图片
 * 返回的文件地址都是 filePath=file:///storage/...
 * */
inc.fileImgFromCameraGallery = function(a,callbackS,callbackE) {
	var fun = {};
		fun.callbackS = function(files,from){
			callbackS && callbackS.call(a,{files:files,from:from});
		};
		fun.callbackE = function(message,orgErr){
			callbackE && callbackE.call(a,{message:message,orgErr:orgErr});
		};
		fun.fromCamera = function(){
			var cmr = plus.camera.getCamera();
			cmr.captureImage(function(path) {
				/**
				 * 注：HBuilder拍照返回的路径path固定是_doc/开头。从相册返回的路径固定是file://开头。
				 * 为了统一，这里的path路径转换为以file://开头的路径。file://路径可以直接用于html中
				 * */
				fun.callbackS([inc.fileAnyToPath(path)],"camera");
			}, function(e) {
				//inc.isDevelop && console.log("取消拍照");
				fun.callbackE('拍照失败',e);
			}, {
				filename: inc.fileCreateDoc()
			});	
		};
		fun.fromGallery = function(){
			//从相册中选择图片
			plus.gallery.pick( function(path){
				fun.callbackS([path],"gallery");
			}, function (e) {
				//inc.isDevelop && console.log("取消选择图片");
				fun.callbackE('选择图片失败',e);
			}, {
				filename : inc.fileCreateDoc(),
				filter : "image"
			});
		};
	a = (a && typeof a === 'object') ? a : {doType:a};
	if (a.doType === 'camera') {
		fun.fromCamera();
	} else if (a.doType === 'gallery') {
		fun.fromGallery();
	} else {
		inc.showActionSheet(['拍照','从相册中选择'],function(s){
			if(s.index == 1){
				fun.fromCamera();
			} else if (s.index == 2){
				fun.fromGallery();
			}
		});
	}
};
/**
 * 图片从相册或拍照中载入时对图片进行旋转、缩放到指定宽高、压缩
 * */
inc.fileImgFromCGToRZCOne = function(a,callbackS,callbackE) {
	a.fileDoc = inc.fileAnyToDoc(a.fileDoc);
	a.quality = a.quality || 80;
	
	var fun = {};
		fun.callbackS = function(s){
			callbackS && callbackS.call(a,{fileDoc:s.fileDoc,width:s.width,height:s.height,size:s.size});
		};
		fun.callbackE = function(message,orgErr){
			callbackE && callbackE.call(a,{message:message,orgErr:orgErr});
		};
		
	inc.fileImgGetWHS({
		fileDoc : a.fileDoc
	},function(s){
		//inc.isDevelop && console.log('inc.fileImgGetWHS-返回图片原始宽高-s-' + inc.printObj(s));
		//限制图片最长边
		var r = inc.fileImgMaxSideToWH(s.width,s.height,800);
		inc.fileImgCompress({
			fileDoc : a.fileDoc,
			width   : r.width,
			height  : r.height,
			quality : a.quality,
			rotate  : 0
		},function(s){
			fun.callbackS(s);
		},function(e){
			fun.callbackE('错误：从相册或拍照时，对图片旋转、缩放、压缩时',e);
		});
	},function(e){
		//inc.isDevelop && console.log('inc.fileImgGetWHS-e-' + inc.printObj(e));
		fun.callbackE('错误：文件不存在',e);
	});
};
/**
 * 将文件复制指定位置，
 * 特别注意：复制到指定位置，在iPhone上容易移动失败，所以尽可能采用采用压缩的方法移动到指定目录
 * 在 aidme-avatar.html 页面使用了本函数（将相册中的图片移动到指定位置）
 * */
inc.fileCopyTo = function(a,callbackS,callbackE) {
	var o = {};
		o.fileDoc = inc.fileAnyToDoc(a.fileDoc);
		o.saveDoc = inc.fileAnyToDoc(a.saveDoc);
	//inc.isDevelop && console.log( inc.printObj(o) );
		
	var fun = {};
		fun.callbackS = function(saveDoc){
			callbackS && callbackS.call(a,{fileDoc:saveDoc});
		};
		fun.callbackE = function(message,orgErr){
			callbackE && callbackE.call(a,{message:message,orgErr:orgErr});
		};
	//注：_www/下只能读不能写入，所以拷贝至指定位置也只能至 _doc/下
	if (o.saveDoc.substr(0,5) === '_doc/') {
		o.saveName = o.saveDoc.substr(5);
	} else {
		fun.callbackE('saveDoc路径不是_doc/路径');
		return;
	}
	//将文件拷贝至指定目录下
	plus.io.resolveLocalFileSystemURL(o.fileDoc, function(entry) {
		plus.io.resolveLocalFileSystemURL("_doc/", function(root) {
			root.getFile(o.saveName, {}, function(file) {
				file.remove(function(s) { //文件已存在则先删除再拷贝
					entry.copyTo(root, o.saveName, function(s) {
						fun.callbackS(o.saveDoc);
					},function(e) {
						fun.callbackE('文件已存在-拷贝文件失败-a',e);
					});
				}, function(e) { 
					fun.callbackE('文件已存在-删除已存在的文件失败-b',e);
				});
			}, function(e) { //文件不存在则直接拷贝
				entry.copyTo(root, o.saveName, function(s) {
					fun.callbackS(o.saveDoc);
				},function(e) {
					fun.callbackE('文件不存在-拷贝文件失败-c',e);
				});
			});
		}, function(e) { 
			fun.callbackE('获取_doc/目录对象失败-d',e);
		});
	}, function(e) {
		fun.callbackE('获取拷贝文件对象失败-e',e);
	});
};
/**
 * 图片-旋转、缩放、压缩
 * */
inc.fileImgCompress = function(a,callbackS,callbackE) {
	a.fileDoc = inc.fileAnyToDoc( a.fileDoc );
	a.saveDoc = inc.fileAnyToDoc( a.saveDoc ) || inc.fileCreateDoc();
	a.width   = inc.anyToInt( a.width );
	a.height  = inc.anyToInt( a.height );
	a.quality = inc.anyToInt( a.quality ) || 80;
	a.rotate  = inc.anyToInt( a.rotate ) || 0;
	a.clip    = a.clip || null;
	
	a.width   = a.width  ? '' + a.width  + 'px' : 'auto';
	a.height  = a.height ? '' + a.height + 'px' : 'auto';
		
	plus.zip.compressImage({
		src      : a.fileDoc,
		dst      : a.saveDoc,
		overwrite: true,
		format   : "jpg",
		width    : a.width,
		height   : a.height,
		quality  : a.quality,
		rotate   : a.rotate,
		clip     : a.clip
	},function(s) {
		callbackS && callbackS.call(a,{ fileDoc:a.saveDoc,width:s.width,height:s.height, size:s.size });
	},function(e) {
		callbackE && callbackE.call(a,{ message:'压缩图片失败',orgErr:e });
	});
};
/**
 * 图片-旋转、压缩
 * */
inc.fileImgRotate = function(a,callbackS,callbackE) {
	a.fileDoc = inc.fileAnyToDoc( a.fileDoc );
	a.saveDoc = inc.fileAnyToDoc( a.saveDoc ) || inc.fileCreateDoc();
	a.quality = inc.anyToInt( a.quality ) || 90;
	a.rotate  = inc.anyToInt( a.rotate ) || 0;

	inc.fileImgCompress({
		fileDoc : a.fileDoc,
		saveDoc : a.saveDoc,
		quality : a.quality,
		rotate  : a.rotate
	},function(s){
		callbackS && callbackS.call(a,{ fileDoc:s.fileDoc,width:s.width,height:s.height,size:s.size });
	},function(e){
		callbackE && callbackE.call(a,{message:'旋转图片失败',orgErr:e});
	});
};
/**
 * 获取图片、宽高、大小
 * */
inc.fileImgGetWHS = function(a,callbackS,callbackE) {
	a.fileDoc  = inc.fileAnyToDoc( a.fileDoc);
	a.filePath = inc.fileAnyToPath(a.fileDoc);
	var fun = {};
		fun.callbackS = function(fileDoc,width,height,size){
			callbackS && callbackS.call(a,{fileDoc:fileDoc,width:width,height:height,size:size});
		};
		fun.callbackE = function(message,orgErr){
			callbackE && callbackE.call(a,{message:message,orgErr:orgErr});
		};
	plus.io.resolveLocalFileSystemURL(a.fileDoc,function(entry){
		entry.getMetadata(function(s){
			var img = new Image();
				img.onload  = function() {
					fun.callbackS(a.fileDoc,this.width,this.height,s.size);
				};
				img.onerror = function() {
					fun.callbackE('错误：Image对象获取宽高');
				};
				img.src = a.filePath;
		},function(e){
			fun.callbackE('错误：获取文件信息');
		});
	},function(e){
		fun.callbackE('错误：打开文件');
	});
};
/**
 * 创建或写入文件
 * */
inc.fileWrite = function(a,callbackS,callbackE) {
	var o = {};
		o.text    = a.text;
		o.fileDoc = inc.fileAnyToDoc(a.fileDoc);
		o.isStart = typeof a.isStart === 'boolean' ? a.isStart : true;

	var fun = {};
		fun.callbackS = function(fileDoc,isStart,text){
			callbackS && callbackS.call(a,{fileDoc:fileDoc,isStart:isStart,text:text});
		};
		fun.callbackE = function(message,orgErr){
			callbackE && callbackE.call(a,{message:message,orgErr:orgErr});
		};
		
	plus.io.resolveLocalFileSystemURL('_doc/', function(root) {
		root.getFile(o.fileDoc, {create:true}, function(entry){
			entry.createWriter(function (writer){
				writer.onwrite = function(e) {
					fun.callbackS(o.fileDoc,o.isStart,o.text);
				};
				writer.seek(o.isStart ? 0 : writer.length);
				writer.write(o.text);
			}, function (e) {
				fun.callbackE('写入文件失败',e);
			});
		}, function(e) {
			fun.callbackE('创建或打开文件失败',e);
		});
	}, function(e) {
		fun.callbackE('获取文件对象失败',e);
	});
};
//删除文件
inc.fileDelete = function(a,callbackS,callbackE) {
	var o = {};
		o.isAll   = a.isAll || false; //递归删除目录,如果操作删除根目录将会删除目录下的文件及子目录，不会删除根目录自身
		o.fileDoc = inc.fileAnyToDoc(a.fileDoc);
		
	var fun = {};
		fun.callbackS = function(fileDoc){
			callbackS && callbackS.call(a,{fileDoc:fileDoc});
		};
		fun.callbackE = function(message,orgErr){
			callbackE && callbackE.call(a,{message:message,orgErr:orgErr});
		};
	//将文件拷贝至指定目录下
	plus.io.resolveLocalFileSystemURL(o.fileDoc, function(entry) {
		if (o.isAll) {
			//递归删除目录
			entry.removeRecursively(function(s) {
				fun.callbackS(o.fileDoc);
			}, function(e) { 
				fun.callbackE('文件已存在-删除失败',e);
			});
		} else {
			//删除单个文件
			entry.remove(function(s) {
				fun.callbackS(o.fileDoc);
			}, function(e) { 
				fun.callbackE('文件已存在-删除失败',e);
			});
		}
	}, function(e) {
		fun.callbackE('文件不存在-删除失败',e);
	});
};
/**
 * 检查文件是否存在
 * */
inc.fileImgExist = function(a,callbackS,callbackE) {
	a.fileDoc = inc.fileAnyToDoc( a.fileDoc);
	//检查本地是否已存在该文件
	plus.io.resolveLocalFileSystemURL(a.fileDoc, function(entry) {
		callbackS && callbackS.call(a,a);
	}, function(e) {
		callbackE && callbackE.call(a,{message:'文件不存在',orgErr:e});
	});
};
//上传文件状态回调函数//task和load都是指向同一个对象
inc.fileUploadOnChanged = function(load,status){
	var loadedSize = load.uploadedSize;//已完成上传文件的大小，单位为字节byte
	var totalSize  = load.totalSize;//上传任务文件的总大小，单位为字节byte
	//这里status=null||200,不能判定是否下载完成,必须再判断load.state=4,成功或失败都等于4
	var fun = {};
		fun.percent = function(loadedSize,totalSize) {
			var percent = inc.anyToFlo( (loadedSize/totalSize)*100,2,false );
			if (percent == 100) {
				inc.showLoadMid(true,'数据处理中...');
			} else {
				inc.showLoadMid(true,'已上传 - ' + percent + '%');
			}
			inc.attrSet('div.inc-popLoadMid','percent',percent);
		};
	if (loadedSize && totalSize) {
		if (load.isChangEd) {
			var ele = inc.strToEle('div.inc-popLoadMid');
			if (ele) {
				if ( inc.equal(100,ele.getAttribute('percent')) ) {
					return null;
				} else {
					fun.percent(loadedSize,totalSize);
				}
			} else {
				fun.percent(loadedSize,totalSize);
			}
		} else {
			load.isChangEd = true;
			fun.percent(loadedSize,totalSize);
		}
	}
};
//下载文件状态回调函数//task和load都是指向同一个对象
inc.fileDownloadOnChanged = function(load,status) {
	var loadedSize = load.downloadedSize;//已完成上传文件的大小，单位为字节byte
	var totalSize  = load.totalSize;//上传任务文件的总大小，单位为字节byte
	//这里status=null||200,不能判定是否下载完成,必须再判断load.state=4,成功或失败都等于4
	var fun = {};
		fun.percent = function(loadedSize,totalSize) {
			var percent = inc.anyToFlo( (loadedSize/totalSize)*100,2,false );
			inc.showLoadMid(true,'已下载 - ' + percent + '%');
			inc.attrSet('div.inc-popLoadMid','percent',percent);
			if (percent == 100) inc.showLoadMid(false);
		};
	if (loadedSize && totalSize) {
		if (load.isChangEd) {
			var ele = inc.strToEle('div.inc-popLoadMid');
			if (ele) {
				if ( inc.equal(100,ele.getAttribute('percent')) ) {
					return null;
				} else {
					fun.percent(loadedSize,totalSize);
				}
			} else {
				fun.percent(loadedSize,totalSize);
			}
		} else {
			load.isChangEd = true;
			fun.percent(loadedSize,totalSize);
		}
	}
};
/*
 * 上传文件
 * */
inc.fileUploadOne = function(a,callbackS,callbackE) {
	a.xUrl      = a.xUrl;
	a.fileDoc   = a.fileDoc;
	a.data      = a.data || {};
	a.onChanged = a.onChanged;
	
	var fun = {};
		fun.callbackS = function(retData){
			callbackS && callbackS.call(a,{retData:retData});
		};
		fun.callbackE = function(message,orgErr){
			callbackE && callbackE.call(a,{message:message,orgErr:orgErr});
		};
	if (!a.xUrl || !a.fileDoc) {
		fun.callbackE('xUrl or fileDoc 参数为空值');
		return;
	}
	if (!a.data.fileKey) {
		 a.data.fileKey = 'fileKey_' + (new Date()).getTime().toString();
	}
	
	//普通用户登录
	a.SuObj = inc.storageItemGet('SuObj','object');
	if (a.SuObj.aidme && a.SuObj.saltB && a.SuObj.codeB) {
		a.data.aidme = a.SuObj.aidme;
		a.data.saltB = a.SuObj.saltB;
		a.data.codeB = a.SuObj.codeB;	
	}
	
	//管理员登录
	a.SaObj = inc.storageItemGet('SaObj','object');
	if (a.SaObj.adminId && a.SaObj.adminSa && a.SaObj.adminCo) {
		a.data.adminId = a.SaObj.adminId;
		a.data.adminSa = a.SaObj.adminSa;
		a.data.adminCo = a.SaObj.adminCo;
	}
	
	a.data.channel = inc.storageChannelGet().channel;//应用商店
	
	//应用程序相关信息
	a.data.appid     = plus.runtime.appid; //当前应用的APPID
	a.data.version   = plus.runtime.version; //应用程序版本
	a.data.deVendor  = plus.device.vendor; //设备的生产厂商
	a.data.deModel   = plus.device.model; //设备的型号
	a.data.osName    = plus.os.name; //系统的名称
	a.data.osVersion = plus.os.version; //系统的版本
	
	/**
	 * method: 网络请求类型，必须是http协议的“POST”
	 * blocksize: 上传任务每次上传的文件块大小（仅在支持断点续传的服务有效），单位为字节，默认值为102400，若设置值小于等于0则表示不分块上传
	 * priority: 上传任务的优先级，数值越大优先级越高//timeout: 上传任务超时时间
	 * retry: 上传任务重试次数，默认为3次//retryInterval: 上传任务重试间隔时间
	 * */
	var task = plus.uploader.createUpload( a.xUrl, 
		{ method:"POST",blocksize:0,priority:++inc.priority,timeout:3600,retry:3,retryInterval:3 },
		function ( upload, status ) {
			if (status == 200) {
				//上传完成回调函数//status-如上传成功其值通常为200
				fun.callbackS(upload.responseText);
			} else {
				fun.callbackE('上传失败',status);
			}
		}
	);
	/**
	 * 向上传任务中添加文件，必须在任务开始上传前调用。若指定的key在任务中已经存在则会添加失败，返回false。
	 * 若添加的文件路径不合法或指定文件不存在，则任务添加操作失败，返回false。若任务已经开始上传，再次调用则会操作失败。
	 * key值不能为数字类型
	 * */
	var retAddFile = task.addFile(a.fileDoc, {key : a.data.fileKey});
	if (retAddFile === true) {
		var retAddData = true;
		for (var p in a.data) {
			//addData:添加上传数据//添加成功则返回true，添加失败则返回false//特别注意value必须为字符串类型
			retAddData = task.addData( inc.anyToStr(p), inc.anyToStr(a.data[p]) );
			if (retAddData === false) {
				break;
			}
		}
		if (retAddData === true) {
			a.onChanged && task.addEventListener( "statechanged", a.onChanged , false );
			task.start();
		}else{
			task && task.abort();
			fun.callbackE('task.addData 添加上传参数失败');
		}
	}else{
		task && task.abort();
		fun.callbackE('task.addFile 添加上传文件失败');
	}
};
/*
 * 下载文件
 * */
inc.fileDownloadOne = function(a,callbackS,callbackE) {
	a.fileImui  = a.fileImui;
	a.saveDoc   = a.saveDoc;
	a.imid      = a.imid;
	a.dirName   = a.dirName;
	a.suffix    = a.suffix;
	a.onChanged = a.onChanged;
	
	var fun = {};
		fun.callbackS = function(fileDoc){
			callbackS && callbackS.call(a,{fileDoc:fileDoc});
		};
		fun.callbackE = function(message,orgErr){
			callbackE && callbackE.call(a,{message:message,orgErr:orgErr});
		};

	var file = {};
		file.fileImui  = a.fileImui ? a.fileImui : (inc.fileAnyToImui(a.imid)+(a.suffix||inc.fileImgSuffix(a.dirName).suffix));
		file.saveDoc   = a.saveDoc ? inc.fileAnyToDoc(a.saveDoc) : inc.fileCreateDoc(a.dirName,a.imid);
		file.onChanged = a.onChanged;
	//inc.isDevelop && console.log('下载-文件地址-' + file.fileImui + '-存储路径-' + file.saveDoc);
	
	//注意:当本地存在相同的文件名时会，load.filename会在源文件名后面加(1)、(2)...
	file.task = plus.downloader.createDownload( file.fileImui, {
		filename:file.saveDoc,priority:++inc.priority,timeout:30,retry:3,retryInterval:3
	}, function ( load, status ) {
		if ( status == 200 ) { //下载完成//load.filename
			fun.callbackS(file.saveDoc);
		}else{
			file.task && file.task.abort();
			fun.callbackE('下载失败',{status:status});
		}
	});
	//检查图片在本地是否存在，不存在则下载
	inc.fileImgExist({
		fileDoc : file.saveDoc,
	},function(s){
		//inc.isDevelop && console.log('下载-已经存在-' + file.fileImui + '-存储路径-' + file.saveDoc);
		fun.callbackS(file.saveDoc);
	},function(e){
		//inc.isDevelop && console.log('下载-正下载中-' + file.fileImui + '-存储路径-' + file.saveDoc);
		file.onChanged && file.task.addEventListener( "statechanged", file.onChanged, false );
		file.task.start();
	});
	return file.task;
};
/**
 * 预加载图片
 * longtime=至少等待多少时间才显示图片，等待时图片也在网络加载中，只是延后显示
 * */
inc.fileImgLoadImageSet = function(eleId,longtime) {
	var images   = [];//保存已加载完毕但暂不显示的图片对象
	var isTout   = false;//true=已走完等待时间
		longtime = typeof longtime === 'number' ? longtime : 777;//等待显示
	var fun = {};
		fun.loadImage = function(iEle,onui) {
			++inc.autoId
			var img = new Image();
				img.onload  = function() {
					if (isTout) {
						this.iEle.setAttribute('src',this.onui);
						inc.images[this.objId] = null;
					} else {
						images.push(this);
					}
				};
				img.onerror = function() {
					if (isTout) {
						this.iEle.setAttribute('src',this.onui);
						inc.images[this.objId] = null;
					} else {
						images.push(this);
					}
				};
				img.onui  = onui;
				img.iEle  = iEle;
				img.objId = 'image_' + inc.autoId;
			inc.images[img.objId] = img;
				img.src   = onui;
			iEle.setAttribute('onis','true');
		};
		fun.loadOne = function(iEle) {
			var onis = iEle.getAttribute('onis');//标记图片已开始加载
			var onui = iEle.getAttribute('onui');//延迟加载的图片地址
			var src  = iEle.getAttribute('src');//加载完毕的图片地址
			if (onui && onui !== src && onis !== 'true') fun.loadImage(iEle,onui);
		};
		fun.loadSrc = function() {
			for (var i=0,len=images.length;i<len;i++) {
				if (images[i]) {
					images[i].iEle.setAttribute('src',images[i].onui);
					inc.images[images[i].objId] = null;
					images[i] = null;
				}
			}
		};
	var ele = inc.strToEle(eleId);
	if (ele) {
		if (ele.nodeName === 'IMG') {
			fun.loadOne(ele);
		} else {
			var eles = ele.querySelectorAll('img');
			for (var i=0,eLen=eles.length;i<eLen;i++) {
				fun.loadOne(eles[i]);
			}
		}
	}
	setTimeout(function(){
		isTout = true;
		fun.loadSrc();
	},longtime);
};
//获取图片的后缀名
inc.fileImgSuffix = function(a) {
	var r = {};
		r.width  = null;
		r.suffix = '';
		a = (a && typeof a === 'object') ? a : { dirName:a };
	
	if (a.dirName === 'saleOblong' || a.dirName === 'artiOblong') {
		a.widthSC = a.widthSC || inc.storageScreenWHGet().width;
		a.spaceLR = a.spaceLR || 0;
		r.width   = a.widthSC - a.spaceLR*2;
		if (r.width <= 300) {
			r.suffix = '!bxa'; return r;
		} else if (r.width > 300 && r.width <= 320) {
			r.suffix = '!bxb'; return r;
		} else if (r.width > 320 && r.width <= 340) {
			r.suffix = '!bxc'; return r;
		} else if (r.width > 340 && r.width <= 360) {
			r.suffix = '!bxd'; return r;
		} else if (r.width > 360 && r.width <= 380) {
			r.suffix = '!bxe'; return r;
		} else if (r.width > 380 && r.width <= 400) {
			r.suffix = '!bxf'; return r;
		} else if (r.width > 400 && r.width <= 420) {
			r.suffix = '!bxg'; return r;
		} else if (r.width > 420 && r.width <= 440) {
			r.suffix = '!bxh'; return r;
		} else if (r.width > 440 && r.width <= 460) {
			r.suffix = '!bxi'; return r;
		} else if (r.width > 460 && r.width <= 480) {
			r.suffix = '!bxj'; return r;
		} else if (r.width > 480 && r.width <= 500) {
			r.suffix = '!bxk'; return r;
		} else if (r.width > 500 && r.width <= 520) {
			r.suffix = '!bxl'; return r;
		} else if (r.width > 520 && r.width <= 540) {
			r.suffix = '!bxm'; return r;
		} else if (r.width > 540 && r.width <= 560) {
			r.suffix = '!bxn'; return r;
		} else if (r.width > 560 && r.width <= 580) {
			r.suffix = '!bxo'; return r;
		} else if (r.width > 580 && r.width <= 600) {
			r.suffix = '!bxp'; return r;
		} else if (r.width > 600 && r.width <= 620) {
			r.suffix = '!bxq'; return r;
		} else if (r.width > 620 && r.width <= 640) {
			r.suffix = '!bxr'; return r;
		} else {
			r.suffix = '!bxr'; return r;
		}
	} else {
		switch(a.dirName){
			case 'faceShare':
				r.suffix = '!axa';//100x100//专用于微信、QQ分享时的logo图片，限32KB
				break;
			case 'avatarMini':
				r.suffix = '!axb';//30x30
				break;
			case 'avatarSmall':
				r.suffix = '!axc';//50x50
				break;
			case 'avatarMiddle':
				r.suffix = '!axe';//100x100
				break;
			case 'avatarLarge':
				r.suffix = '!axg';//300x300
				break;
		}
	}
	return r;
};
//获取网络信息
inc.networkinfo = function() {
    var types = {};
	    types[plus.networkinfo.CONNECTION_UNKNOW]   = "unknow";//未知
	    types[plus.networkinfo.CONNECTION_NONE]     = "none";//未连接网络
	    types[plus.networkinfo.CONNECTION_ETHERNET] = "ethernet";//有线网络
	    types[plus.networkinfo.CONNECTION_WIFI]     = "wifi";//WiFi网络
	    types[plus.networkinfo.CONNECTION_CELL2G]   = "2g";//2G蜂窝网络
	    types[plus.networkinfo.CONNECTION_CELL3G]   = "3g";//3G蜂窝网络
	    types[plus.networkinfo.CONNECTION_CELL4G]   = "4g";//4G蜂窝网络
	return types[plus.networkinfo.getCurrentType()];
};