var pul = {};
	pul.b = {}; //默认分类首次加载时传入值
	pul.fun = {}; //函数
	pul.letts = ['a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z'];
	pul.lists = {}; //储存所有已加载过的列表内容，不区分类别，不需要清空或重置
	pul.sorts = null; //默认分类首次加载时必须初始化数据//初始加载时一定是加载第一个属性类别，不能指定初始加载属性
	pul.value = {};//变量值
	pul.value.self     = null; //当前窗口对象
	pul.value.autoId   = 1; //自动序列号
	pul.value.isFirst  = false; //默认类首次加载
	pul.value.isScroll = true; //true=存储scrollTop，false=不存储。当切换类别时先false然后true
	pul.value.downtime = 0; //下拉起始时间，单位毫秒
	pul.value.puuptime = 0; //上拉起始时间，单位毫秒
	pul.value.autotime = 0; //首次起始时间，单位毫秒
	pul.value.isListLoadIng   = false; //true=数据加载中
	pul.value.isPullUpDisable = false; /*true=禁用上拉刷新-false=上拉刷新可用-bug-必须触发一次系统的上拉刷新才能完全禁用上拉刷新*/
	pul.fixed = {};//常量值
	pul.fixed.uiType   = 2; //1=android和 iOS都使用mui上下拉刷新，2=仅限android使用mui，iOS使用自定义js实现上下拉刷新
	pul.fixed.firstime = 777; //默认类第一页加载持续时间，单位毫秒
	pul.fixed.secotime = 777; //其他类第一页加载持续时间，单位毫秒
	pul.fixed.docatime = 999; //下拉动画持续时间，单位毫秒

pul.fun.contList = function(a,callbackS,callbackE) {
	var o = {};
	/**下列赋值仅用于查阅，这些属性会排在前面**/
	o.page   = 0;
	o.size   = 0;
	o.count  = 0;
	o.alls   = 0;
	/***传值***********************************/
	o.puType = a.puType; //up=上拉刷新样式，down=下拉刷新样式
	o.xUrl   = a.xUrl || ''; //加载地址
	o.data   = a.data || {}; //传递给服务器的数据
	o.doFrom = a.doFrom || ''; //判断处理，例如：indexHot，indexNew
	o.doType = a.doType || ''; //判断处理，例如：indexHot，indexNew
	o.unique = a.unique || null; //指定服务器数据库中唯一字段名称
	o.ulName = a.ulName || 'pullList'; //指定ul的className
	o.isHtml = typeof a.isHtml === 'boolean' ? a.isHtml : true; //isHtml=true加载完成后直接设置html内容
	o.doSort = pul.sorts.doSort; //判断哪个分类，每个列表页至少有一个类别a
	o.callbackS = callbackS;
	o.callbackE = callbackE;
	//inc.isDevelop && console.log( 'o-' + inc.printObj(o) );
	
	//类别数据可以覆盖a.data数据
	var t = pul.sorts[o.doSort];
	if (t.data && typeof t.data === 'object') {
		for (var i in t.data) {
			o.data[i] = t.data[i];
		}
	}
	//如果是下拉刷新，则不更新page等信息
	o.data.page   = o.puType === 'down' ? 1 : ( t.page + 1 );
	o.data.puType = o.puType;//传至服务器刷新类型
	inc.ajax.send({
		xUrl : o.xUrl,
		data : o.data
	},{
		backRArgs : o,
		callbackS : pul.fun.xhr_contList
	},{
		backRArgs : o,
		callbackE : o.callbackE
	});
}
/**
 * 下拉刷新有内容就立即显示，但动画必须延时关闭
 * 上拉刷新有内容就立即显示，但首次必须延时显示
 * */
pul.fun.xhr_contList = function(xhrRet) {
	//inc.isDevelop && console.log( 'xhrRet-' + xhrRet.retData );
	var retObj = inc.ajax.xhrToEval(xhrRet.retData);
	var o = xhrRet.backRArgs;
	if (!pul.fun.compareDoSort(o)) return;
	if (retObj.retStr === 'ok') {
		var r = retObj.lists;
		o.page  = inc.anyToInt( retObj.page );
		o.size  = inc.anyToInt( retObj.size );
		o.count = inc.anyToInt( retObj.count );
		o.rHtml = null; //注意：此处只能初始为null不能为空
		o.other = retObj.other || {};//用于加载其它特定内容
		o.isNew = false;//下拉刷新是否更新内容
		
		var t = pul.sorts[o.doSort];
		//down=下拉刷新，重置内容。up=上拉刷新，追加至尾部
		if (o.puType === 'up') {
			t.page  = o.page;
			t.size  = o.size;
			t.count = o.count;
			t.alls  = t.alls + o.count
			o.alls  = t.alls;
			o.rHtml = pul.rHtmlRet(o,r);
			o.callbackS && o.callbackS.call(o,xhrRet);
		} else if (o.puType === 'down') {
			if (o.count == 0) {
				o.isNew = true;
			} else {
				for (var i=0;i<r.length;i++) {
					if ( !inc.equal(r[i][o.unique], t.saves[i]) ) {
						o.isNew = true;
						break;
					}
				}
			}
			if (o.isNew) {
				//当下拉刷新有更新时
				//重置t.saves
				t.saves = [];
				for (var i=0;i<r.length;i++) {
					t.saves.push(r[i][o.unique]);
				}
				//重置t.scrollTop
				t.scrollTop = 0;
				//重置t.page...t.alls
				t.page  = 1;
				t.size  = o.size;
				t.count = o.count;
				t.alls  = o.count;
				o.alls  = t.alls;
				o.rHtml = pul.rHtmlRet(o,r);
			} else {
				//原值赋值
				t.alls = t.alls;
				o.alls = t.alls;
			}
			o.callbackS && o.callbackS.call(o,xhrRet);
		}
	}else{
		o.callbackE && o.callbackE.call(o,xhrRet);
	    //返回错误信息
	    var retErr = inc.ajax.errorFirst(retObj.retStr);
	    if ( retErr === false ) {
			inc.ajax.errorFinal(retObj.retStr);
	    }
	}
};
/**
 * doSort 作为当前下拉上拉刷新的唯一识别Id，如果比对不一致则是不同类别下拉上拉刷新
 * */
pul.fun.compareDoSort = function(a) {
	return a.doSort === pul.sorts.doSort;
};
/**
 * 下拉刷新有内容就立即显示，但动画必须延时关闭
 * */
pul.fun.pullRefreshDown = function() {
	var a = pul.b.a, callbackS = pul.b.callbackS, callbackE = pul.b.callbackE;
		a.puType = 'down';
	pul.value.downtime = inc.localtime(true);
	if (pul.value.isListLoadIng !== true) {
		pul.value.isListLoadIng = true;
		pul.fun.contList(a,function(xhrRet){
			//inc.isDevelop && console.log( 'this-' + inc.printObj(this,['callbackS','callbackE']) );
			//inc.isDevelop && console.log( 'down-' + xhrRet.retData );
			var o = this;
			if (o.isNew) {
				if (o.isHtml) {
					inc.htmlSet('ul.pullList.' + o.doSort,o.rHtml);//尾部追加
					pul.fun.pullListChageShow(o.doSort);//显示当前类别的列表容器
					pul.fun.pullRefreshDownRet(o);//显示或隐藏加载完毕有底线的空空如也
					pul.fun.contentHeight();//计算容器高度
				}
			} else {
				o.isHtml && pul.fun.pullRefreshDownRet(o);
			}
			setTimeout(function() {
				pul.fun.pullRefreshDownEnd();//下拉刷新结束
				pul.value.isListLoadIng = false;
			},inc.longToTime(pul.value.downtime,pul.fixed.docatime));
			callbackS && callbackS.call(o,xhrRet);
		},function(e){
			//inc.isDevelop && console.log( 'e-' + inc.printObj(e) );
			var o = this;
			setTimeout(function() {
				pul.fun.pullRefreshDownEnd();//下拉刷新结束
				pul.value.isListLoadIng = false;
			},inc.longToTime(pul.value.downtime,pul.fixed.docatime));
			callbackE && callbackE.call(o,e);
		});
	} else {
		setTimeout(function() {
			pul.fun.pullRefreshDownEnd();//下拉刷新结束
		},inc.longToTime(pul.value.downtime,pul.fixed.docatime));
		callbackE && callbackE.call(a,{message:'正在加载中...'});
	}
};
pul.fun.pullRefreshDownRet = function(o) {
	if (o.isNew) {
		pul.fun.pullRefreshUpRet(o);
	}
};
/**
 * 上拉刷新有内容就立即显示，但首次必须延时显示
 * */
pul.fun.pullRefreshUp = function() {
	if (pul.value.isPullUpDisable) {
		return;//true=标记禁止上拉刷新
	}
	var a = pul.b.a, callbackS = pul.b.callbackS, callbackE = pul.b.callbackE;
		a.puType = 'up';
	pul.value.puuptime = inc.localtime(true);
	if (pul.value.isListLoadIng !== true) {
		pul.value.isListLoadIng = true;
		inc.htmlHide('.inc-listNone');//加载完毕-空空如也
		inc.htmlHide('.inc-listFini');//加载完毕-有底线的
		pul.fun.pullUpLoadChangeIos('load');//加载中...
		pul.fun.contList(a,function(xhrRet){
			//inc.isDevelop && console.log( 'this-' + inc.printObj(this,['callbackS','callbackE']) );
			//inc.isDevelop && console.log( 'up-' + xhrRet.retData );
			var o = this;
			if (pul.value.isFirst) {
				pul.value.isFirst = false;
				setTimeout(function(){
					if (o.isHtml) {
						inc.htmlAppend('ul.pullList.' + o.doSort,o.rHtml);//尾部追加
						pul.fun.pullListChageShow(o.doSort);//显示当前类别的列表容器
						pul.fun.pullRefreshUpRet(o);//显示或隐藏加载完毕有底线的空空如也
						pul.fun.contentHeight();//计算容器高度
					} else {
						o.isHtml && pul.fun.pullRefreshUpRet(o);
					}
					callbackS && callbackS.call(o,xhrRet);
					pul.value.isListLoadIng = false;
				},inc.longToTime(pul.value.autotime,pul.fixed.firstime));
			} else {
				if (o.isHtml) {
					inc.htmlAppend('ul.pullList.' + o.doSort,o.rHtml);//尾部追加
					pul.fun.pullListChageShow(o.doSort);//显示当前类别的列表容器
					pul.fun.pullRefreshUpRet(o);//显示或隐藏加载完毕有底线的空空如也
					pul.fun.contentHeight();//计算容器高度
				} else {
					o.isHtml && pul.fun.pullRefreshUpRet(o);
				}
				callbackS && callbackS.call(o,xhrRet);
				pul.value.isListLoadIng = false;
			}
		},function(e){
			//inc.isDevelop && console.log( 'e-' + inc.printObj(e) );
			var o = this;
			pul.fun.pullRefreshUpEnd(false);//仍可上拉加载
			callbackE && callbackE.call(o,e);
			pul.value.isListLoadIng = false;
		});
	} else {
		pul.fun.pullRefreshUpEnd(false);//仍可上拉加载
		callbackE && callbackE.call(a,{message:'正在加载中...'});
	}
};
pul.fun.pullRefreshUpRet = function(o) {
	if (o.alls === 0 || o.count === 0 || o.count < o.size) {
		if (o.alls >= 1) {
			inc.htmlShow('.inc-listFini');//加载完毕-有底线的
			inc.htmlHide('.inc-listNone');//加载完毕-空空如也
		} else {
			inc.htmlHide('.inc-listFini');//加载完毕-有底线的
			inc.htmlShow('.inc-listNone');//加载完毕-空空如也
		}
		pul.fun.pullRefreshUpEnd(true);//结束上拉加载
		pul.fun.pullRefreshUpDisable();//禁止上拉加载
	} else {
		inc.htmlHide('.inc-listFini');//加载完毕-有底线的
		inc.htmlHide('.inc-listNone');//加载完毕-空空如也
		pul.fun.pullRefreshUpEnable();//启用上拉加载
		pul.fun.pullRefreshUpEnd(false);//仍可上拉加载
	}
};
/**
 * 结束上拉加载
 * 加载完新数据后，需要执行endPullupToRefresh()方法，结束转雪花进度条的“正在加载...”过程
 * 是否还有更多数据；若还有更多数据，则传入false; 否则传入true，之后滚动条滚动到底时，
 * 将不再显示“上拉显示更多”的提示语，而显示“没有更多数据了”的提示语；
 * endPullupToRefresh(true)  参数为true代表没有更多数据了
 * endPullupToRefresh(false) 参数为false代表还有数据仍可上拉加载
 * */
pul.fun.pullRefreshUpEnd = function(noMore) {
	if (pul.fixed.uiType === 1) {
		mui('#pullContainer').pullRefresh().endPullupToRefresh(noMore);
	} else if (pul.fixed.uiType === 2) {
		if (inc.isAndroid()) {
			mui('#pullContainer').pullRefresh().endPullupToRefresh(noMore);
		} else {
			if (noMore) {
				pul.fun.pullUpLoadChangeIos('hide');
			} else {
				pul.fun.pullUpLoadChangeIos('more');
			}
		}
	}
};
/**
 * 禁用上拉刷新
 * 在部分场景下希望禁用上拉加载，比如在列表数据过少时，不想显示“上拉显示更多”、“没有更多数据”的提示语，
 * 开发者可以通过调用disablePullupToRefresh()方法实现类似需求
 * */
pul.fun.pullRefreshUpDisable = function() {
	if (pul.fixed.uiType === 1) {
		pul.value.isPullUpDisable = true;//true=标记禁用上拉刷新
		mui('#pullContainer').pullRefresh().disablePullupToRefresh();
	} else if (pul.fixed.uiType === 2) {
		if (inc.isAndroid()) {
			pul.value.isPullUpDisable = true;//true=标记禁用上拉刷新
			mui('#pullContainer').pullRefresh().disablePullupToRefresh();
		} else {
			pul.value.isPullUpDisable = true;//true=标记禁用上拉刷新
			pul.fun.pullUpLoadChangeIos('hide');
		}
	}
};
/**
 * 重置上拉加载
 * 若部分业务中，有重新触发上拉加载的需求（比如当前类别已无更多数据，但切换到另外一个类别后，应支持继续上拉加载），
 * 此时调用.refresh(true)方法，可重置上拉加载控件
 * */
/**
 * 启用上拉加载
 * 使用disablePullupToRefresh()方法禁用上拉加载后，可通过enablePullupToRefresh()方法再次启用上拉加载
 * */
pul.fun.pullRefreshUpEnable = function() {
	if (pul.fixed.uiType === 1) {
		pul.value.isPullUpDisable = false;//false=标记上拉刷新可用
		mui('#pullContainer').pullRefresh().refresh(true);//重置上拉加载
		mui('#pullContainer').pullRefresh().enablePullupToRefresh();
	} else if (pul.fixed.uiType === 2) {
		if (inc.isAndroid()) {
			pul.value.isPullUpDisable = false;//false=标记上拉刷新可用
			mui('#pullContainer').pullRefresh().refresh(true);//重置上拉加载
			mui('#pullContainer').pullRefresh().enablePullupToRefresh();
		} else {
			pul.value.isPullUpDisable = false;//false=标记上拉刷新可用
			pul.fun.pullUpLoadChangeIos('more');
		}
	}
};
/**
 * 下拉刷新结束
 * 在下拉刷新过程中，当获取新数据后，需要执行endPulldownToRefresh方法，
 * 该方法的作用是关闭“正在刷新”的雪花进度提示，内容区域回滚顶部位置
 * */
pul.fun.pullRefreshDownEnd = function() {
	if (pul.fixed.uiType === 1) {
		mui('#pullContainer').pullRefresh().endPulldownToRefresh();
	} else if (pul.fixed.uiType === 2) {
		if (inc.isAndroid()) {
			mui('#pullContainer').pullRefresh().endPulldownToRefresh();
		} else {
			pul.value.self.endPullToRefresh();
		}
	}
};
/**
 * 容器高度小于屏幕高度时指定容器高度为容器高度，否则auto
 * */
pul.fun.contentHeight = function() {
	var fun = {};
		fun.setHeight = function() {
			var ele = inc.strToEle('#pullContainer');
			if (ele) {
				var scrollHeight = inc.anyToInt( ele.scrollHeight );
				var styles = plus.webview.currentWebview().getStyle();
				var styleHeight  = inc.anyToInt( styles.height );
				if (styleHeight >= 1 && scrollHeight <= styleHeight) {
					ele.style.height = styleHeight + 'px';
				} else {
					ele.style.height = 'auto';
				}
			}
		};
	inc.htmlHide('.inc-listDown',true);
	inc.htmlHide('.inc-listFake',true);
	inc.fileImgLoadImageSet('#pullContainer');
	if (pul.fixed.uiType === 2) {
		//ios端内容不足一屏记为一屏，避免内容不足一屏时，非内容区域无法触发下拉刷新
		if (inc.isIOS()) {
			setTimeout(function() {
				fun.setHeight();
				setTimeout(function() {
					fun.setHeight();
				}, 488);
			}, 288);
		}
	}
};
/**
 * 
 * 当pul.fixed.uiType=2时，ios上拉刷新-提示状态
 * */
pul.fun.pullUpLoadChangeIos = function(doWhat) {
	if (doWhat === 'more') {
		inc.htmlShow('.pullContainer.ios .inc-listPuup');
		inc.htmlSet( '.pullContainer.ios .inc-listPuup','上拉加载更多');
	} else if (doWhat === 'load') {
		inc.htmlShow('.pullContainer.ios .inc-listPuup');
		inc.htmlSet( '.pullContainer.ios .inc-listPuup','<span class="mui-spinner a"></span><span class="b">加载中...</span>');
	} else if (doWhat === 'hide') {
		inc.htmlHide('.pullContainer.ios .inc-listPuup');
		inc.htmlSet( '.pullContainer.ios .inc-listPuup','上拉加载更多');
	}
};
/**
 * 同一窗口切换不同类别上下拉刷新
 * */
pul.fun.pullListChangeLoad = function(doSort) {
	pul.value.isScroll = false;
	
	pul.sorts.doSort = doSort;//切换至某类别
	var t = pul.sorts[doSort];
	
	pul.fun.pullRefreshDownEnd();//下拉刷新结束
	pul.fun.pullRefreshUpEnd(true);//结束上拉加载
	pul.fun.pullRefreshUpDisable();//禁止上拉加载
	
	pul.value.isListLoadIng = false;
	if (t.page === 0) {
		if (inc.strToEle('.inc-listFake')) {
			inc.htmlShow('.inc-listFake');
		} else {
			inc.htmlPrepend('#pullContainer',inc.listFakeHtml());
		}
		if (inc.strToEle('.inc-listDown')) {
			inc.htmlShow('.inc-listDown');
		} else {
			inc.htmlAppend('body',inc.listDownHtml());
		}
		inc.htmlHide('.inc-listNone');
		inc.htmlHide('.inc-listFini');
		pul.fun.pullRefreshUpEnable();//启用上拉加载
		pul.fun.pullRefreshUpEnd(false);//仍可上拉加载
		//开始加载内容
		pul.fun.pullRefreshUp();//开始加载内容
	} else {
		pul.fun.pullRefreshUpRet(t);
	}
	//显示当前类别列表容器
	pul.fun.pullListChageShow(pul.sorts.doSort);
	inc.scrollToFixed({scrollTop:t.scrollTop});
	
	pul.value.isScroll = true;
};
/**
 * 显示当前类别列表容器
 * */
pul.fun.pullListChageShow = function(doSort){
	if (pul.b.a.doFrom === 'indexSame') {
		if (doSort === 'a') {
			inc.htmlShow('#pullContainer div.pullTop #sliderA');
		} else {
			inc.htmlHide('#pullContainer div.pullTop #sliderA');
		}
	}
	inc.htmlShow('#pullContainer ul.pullList.' + doSort);
	for (var i in pul.sorts.letts) {
		 var k  = pul.sorts.letts[i];
		if ( k != doSort) {
			inc.htmlHide('#pullContainer ul.pullList.' + k);
		}
	}
};
/**
 * 添加容器
 * */
pul.fun.pullContainer = function(a) {
	a.ulName  = a.ulName || '';
	a.doFrom  = a.doFrom || '';
	a.pullTop = a.pullTop || '';
	
	if (!inc.strToEle('#pullContainer')) {
		//初始化类别数据
		if (pul.sorts) {
			var doSort = '';//获取第一个类别属性
			for (var i in pul.sorts) {
				if (pul.sorts[i] && typeof pul.sorts[i] === 'object') {
					doSort = i;//规定doSort只能是a-z某个单字母
					break;
				}
			}
			pul.sorts.letts  = [];//全部属性//仅能在此初始化或指定
			pul.sorts.doSort = pul.sorts.doSort || doSort;
			for (var i in pul.letts) {
				 var k =  pul.letts[i];//规定doSort只能是a-z某个单字母
				if (pul.sorts[k] && typeof pul.sorts[k] === 'object') {
					pul.sorts[k].data  = pul.sorts[k].data || {};
					pul.sorts[k].page  = 0;
					pul.sorts[k].size  = 0;
					pul.sorts[k].count = 0;
					pul.sorts[k].alls  = 0;
					pul.sorts[k].saves = [];
					pul.sorts[k].scrollTop = 0;
					pul.sorts.letts.push(k);
				}
			}
		} else {
			pul.sorts = {
				a : {
					data  : {}, //POST到服务器的数据
					page  : 0,
					size  : 0,
					count : 0,
					alls  : 0,
					saves : [], //临时保存第一页的唯一识别Id
					scrollTop : 0, //滚过顶部的距离
				},
				letts  : ['a'], //全部属性//仅能在此初始化或指定
				doSort : 'a', //当前正在加载那个类别数据，默认为a
			}; //不同类别的数据，在首次加载时初始化
		}
		//类别列表容器
		var pullMid = '';
		for (var i in pul.letts) {
			 var k =  pul.letts[i];
			if (pul.sorts[k] && typeof pul.sorts[k] === 'object') {
				pullMid += '<ul class="mui-table-view mui-table-view-chevron pullList '+k+' '+a.ulName+' inc-bg-space"></ul>';
			}
		}
		//整个容器
		var fHtml = inc.listFakeHtml();
		var dHtml = inc.listDownHtml(a.doFrom === 'indexSame' ? 'hide' : '');
		var pHtml = '';
		var aHtml = '<div class="mui-content mui-scroll-wrapper pullContainer android" id="pullContainer">'+
						fHtml+
						'<div class="mui-scroll">'+
							'<div class="pullTop">'+ a.pullTop +'</div>'+
							'<div class="pullMid">'+ pullMid +'</div>'+
							'<div class="pullBot">'+
								'<ul>'+
									'<li class="inc-listNone">空空如也</li>'+
									'<li class="inc-listFini">----- 我是有底线的 -----</li>'+
								'</ul>'+
							'</div>'+
						'</div>'+
					'</div>'+dHtml;
		var iHtml = '<div class="mui-content pullContainer ios" id="pullContainer">'+
						fHtml+
						'<div class="pullTop">'+ a.pullTop +'</div>'+
						'<div class="pullMid">'+ pullMid +'</div>'+
						'<div class="pullBot">'+
							'<ul>'+
								'<li class="inc-listNone">空空如也</li>'+
								'<li class="inc-listFini">----- 我是有底线的 -----</li>'+
								'<li class="inc-listPuup">'+
									'<span class="mui-spinner a"></span><span class="b">加载中...</span>'+
								'</li>'+
							'</ul>'+
						'</div>'+
					'</div>'+dHtml;
		if (pul.fixed.uiType === 1) {
			pHtml = aHtml;
		} else if (pul.fixed.uiType === 2) {
			if (inc.isAndroid()) {
				pHtml = aHtml;
			} else {
				pHtml = iHtml;
			}
		}
		inc.htmlAppend('body',pHtml);
	}
};
/**
 * 特别注意在加载pull.js的页面中不能 mui.init()，
 * 否则 pul.fun.pullRefresh 函数中的 mui.init(init); 不会被执行
 * */
pul.fun.pullRefresh = function(a,callbackS,callbackE) {
	pul.value.isFirst  = true;
	pul.value.isScroll = true;
	pul.value.self     = plus.webview.currentWebview();
	pul.value.autotime = inc.localtime(true);
	pul.b.a = a;
	pul.b.callbackS = callbackS;
	pul.b.callbackE = callbackE;
	//inc.isDevelop && console.log( 'pul.b-' + inc.printObj(pul.b) );
	
	//初始化类别数据//初始化列表容器
	pul.fun.pullContainer(pul.b.a);
	
	var fun = {};
	var init = {};
		init.pullRefresh = {
			container : '#pullContainer',
			down : { callback : pul.fun.pullRefreshDown },
			up   : { callback : pul.fun.pullRefreshUp, auto : true, contentnomore : '' }	
		};
		init.gestureConfig = {
			tap: true, //单击屏幕//默认为 true
			doubletap: false, //双击屏幕//默认为 false
			longtap: false, //长按屏幕//默认为 false
			swipe: true, //滑动//默认为 true
			drag: true, //拖动//默认为 true
			hold:false, //按住屏幕//默认为 false，不监听
			release:false //离开屏幕//默认为 false，不监听
		};
		fun.pullRefreshUp = function() {
			var isOk = false;
			var tInt = setInterval(function(){
				if (!isOk && mui && mui('#pullContainer') && mui('#pullContainer').pullRefresh) {
					isOk = true;
					tInt && clearInterval(tInt);
					pul.fun.pullRefreshUp();
				} else {
					tInt && clearInterval(tInt);
				}
			},100);
		};
	if (pul.fixed.uiType === 1) {
		mui.init(init);
		window.onscroll = function(){
			inc.windowScroll(null,function(s){
				//inc.isDevelop && console.log( 'inc.windowScroll-' + inc.printObj(s) );
				if (pul.value.isScroll) {
					var t = pul.sorts[pul.sorts.doSort];
						t.scrollTop = s.scrollTop;
				}
			});
		};
	} else if (pul.fixed.uiType === 2) {
		if (inc.isAndroid()) {
			mui.init(init);
			window.onscroll = function(){
				inc.windowScroll(null,function(s){
					//inc.isDevelop && console.log( 'inc.windowScroll-' + inc.printObj(s) );
					if (pul.value.isScroll) {
						var t = pul.sorts[pul.sorts.doSort];
							t.scrollTop = s.scrollTop;
					}
				});
			};
		} else {
			pul.fun.pullUpLoadChangeIos('more');
			pul.value.self.setPullToRefresh({
				support : true,
				height  : '50px',
				range   : '100px',
				style   : 'circle',
				offset  : '1px'
			},pul.fun.pullRefreshDown);
			//第一次上拉加载
			pul.fun.pullRefreshUp();
			window.onscroll = function(){
				inc.windowScroll(null,function(s){
					//inc.isDevelop && console.log( 'inc.windowScroll-' + inc.printObj(s) );
					if (pul.value.isScroll) {
						var t = pul.sorts[pul.sorts.doSort];
							t.scrollTop = s.scrollTop;
					}
					if (s.scrollBottom === 0 && s.scrollTop !== 0) {
						if (pul.value.isPullUpDisable === false) {
							pul.fun.pullRefreshUp();
						}
					}
				});
			};
		}
	}
};
/**
 * 懒加载类别列表内容
 * type=1-页面创建时不加载，点击显示该页面时再加载
 * type=2-页面创建时加载并显示列表。
 * type=3-页面创建时加载，点击显示该页面时再显示列表。
 * */
pul.pullLazyLoad = function(a,callbackS) {
	a.type      = a.type;
	a.data      = a.data;//必填
	a.callbackS = a.callbackS;
	a.callbackE = a.callbackE;
	
	var fun = {};
		fun.b = {};
		fun.b.type   = a.type || 1;
		fun.b.r      = null;
		fun.b.isTap  = false;//是否已在底部导航页面点击显示该页面
		fun.b.isShow = false; //是否已显示第一页内容
		fun.b.isLoad = false; //避免监听事件后重复加载
		fun.pullRefresh = function(){
			if (fun.b.isLoad) return;
				fun.b.isLoad = true;
			pul.fun.pullRefresh(a.data,function(xhrRet){
				a.callbackS && a.callbackS.call(this,xhrRet);
				fun.b.r = this;
				if (fun.b.type === 1 || fun.b.type === 3) {
					//1=页面创建时不加载，点击显示该页面时再加载//3=页面创建时加载并显示列表
					pul.pullLazyHtml(fun.b.r);	
				} else if (fun.b.type === 2) {
					//2=页面创建时加载，点击显示该页面时再显示列表
					fun.b.isShow && pul.pullLazyHtml(fun.b.r);
				}
			},function(e){
				a.callbackS && a.callbackS.call(this,e);
			});
			callbackS && callbackS.call(a,a);
		};
		fun.setInterval = function() {
			var tInt = setInterval(function(){
				if (fun.b.r) {
					clearInterval(tInt);
					fun.b.isShow = true;
					pul.pullLazyHtml(fun.b.r);
					pul.fun.pullRefreshUpRet(fun.b.r);
				}
			},250);
		};
	if (fun.b.type === 2 || fun.b.type === 3) {
		fun.pullRefresh();
	} else if (fun.b.type === 1) {
		pul.fun.pullContainer({
			ulName : a.data.ulName,
			doFrom : a.data.doFrom,
		});
	}
	//触发加载
	document.addEventListener('pullLoadStart',function (e) {
		if (fun.b.type === 1) {
			fun.pullRefresh();
		} else if (fun.b.type === 2) {
			if (fun.b.isTap !== true) {
				fun.b.isTap = true;
				fun.setInterval();
			}
		}
	},false);
};
/**
 * 两种情况用到该函数
 * 1、懒加载类别列表内容
 * 2、当 isHtml=false 时
 * */
pul.pullLazyHtml = function(r) {
	if (r.puType === 'up') {
		inc.htmlAppend('ul.pullList.' + r.doSort,r.rHtml);//尾部追加
		pul.fun.pullListChageShow(r.doSort);//显示当前类别的列表容器
		pul.fun.pullRefreshUpRet(r);//显示或隐藏加载完毕有底线的空空如也
		pul.fun.contentHeight();//计算容器高度
	} else {
		if (r.isNew) {
			inc.htmlSet('ul.pullList.' + r.doSort,r.rHtml);//重置内容
			pul.fun.pullListChageShow(r.doSort);//显示当前类别的列表容器
			pul.fun.pullRefreshUpRet(r);//显示或隐藏加载完毕有底线的空空如也
			pul.fun.contentHeight();//计算容器高度
		} else {
			pul.fun.pullRefreshDownRet(r);
		}
	}
};
